package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProduceSnExt;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.BomTakeEffectModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.WmsBomTotalModel;
import io.swagger.annotations.ApiOperation;

import java.io.IOException;
import java.util.List;


/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年03月27日 15:42
 */
public interface IBomTakeEffectService {

    /**
     * @Description: 通过条码查询产品条码信息
     * @Param [serialNumber, organizeCode]
     * @Date 2021/3/27 15:45
     **/
    @ApiOperation(value = "通过条码查询产品条码信息", notes = "通过条码查询产品条码信息")
    MesProduceSnExt queryProduceSnBySn(String serialNumber, String organizeCode);

    /**
     * @Description: 通过父级物料查询WmsBomTotal信息
     * @Param [partNo, organizeCode]
     * @return java.util.List<cn.estsh.i3plus.ext.mes.pcn.pojo.model.WmsBomTotalModel>
     * @Date 2021/3/29 15:12
     **/
    @ApiOperation(value = "通过父级物料查询WmsBomTotal信息", notes = "通过父级物料查询WmsBomTotal信息")
    List<WmsBomTotalModel> queryWmsBomTotalByPartNo(String partNo, String organizeCode) throws IOException;

   /**
    * @Description: 点击确认生效
    * @Param [wmsBomTotalModels, organizeCode, userName]
    * @return void
    * @Date 2021/3/29 15:00
    **/
    @ApiOperation(value = "点击确认生效", notes = "点击确认生效")
    void doEffect(BomTakeEffectModel bomTakeEffectModel) throws IOException;
}
