package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesConsistencyAffirmRecord;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.WorkOrderInfoModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/02/07 15:46
 * @Description:
 **/
public interface IConsistencyAffirmRecordService {

    /**
     * 产生一致性确认记录
     * @param workOrderInfoModel 工单信息
     */
    @ApiOperation(value = "产生一致性确认记录", notes = "产生一致性确认记录")
    void insertConsistencyAffirmRecord(WorkOrderInfoModel workOrderInfoModel);

    /**
     * 查询一致性确认记录明细
     *
     * @param orderNo
     * @param organizeCode
     * @return
     */
    @ApiOperation(value = "查询一致性确认记录明细", notes = "查询一致性确认记录明细")
    List<MesConsistencyAffirmRecord> queryConsistencyAffirmRecord(String orderNo, String organizeCode);

    /**
     * 一致性确认记录作业
     *
     * @param consistencyAffirmRecord
     * @return
     */
    @ApiOperation(value = "一致性确认记录作业", notes = "一致性确认记录作业")
    void updateConsistencyAffirmRecord(MesConsistencyAffirmRecord consistencyAffirmRecord);

    /**
     * 输入备注
     *
     * @param consistencyAffirmRecord
     * @return
     */
    @ApiOperation(value = "输入备注", notes = "输入备注")
    void updateConsistencyAffirmRecordMemo(MesConsistencyAffirmRecord consistencyAffirmRecord);

}
