package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesExteriorScratchProofDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesExteriorScratchProofDetailModel;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCell;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/03/15 15:46
 * @Description:
 **/
public interface IExteriorScratchProofCheckService {

    /**
     * 按条件查询外观防划伤点检明细
     *
     * @param orderNo
     * @param organizeCode
     * @return
     */
    @ApiOperation(value = "按条件查询外观防划伤点检明细", notes = "按条件查询外观防划伤点检明细")
    List<MesExteriorScratchProofDetailModel> queryExteriorScratchProofDetailByCell(String orderNo, String organizeCode, String workCellCode);

    /**
     * 通过单据编号查询工位
     *
     * @param orderNo
     * @param organizeCode
     * @return
     */
    List<MesWorkCell> queryCellByOrderNo(String orderNo, String organizeCode);

    /**
     * 外观防划伤点检作业
     *
     * @param exteriorScratchProofDetail
     * @return
     */
    void updateExteriorScratchProof(MesExteriorScratchProofDetail exteriorScratchProofDetail);


}
