package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.pojo.mes.bean.MesConfig;
import cn.estsh.i3plus.pojo.mes.bean.MesFile;
import cn.estsh.i3plus.pojo.platform.bean.SysFile;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.multipart.MultipartFile;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IFileManageService {

    /**
     * 上传文件
     * @param file 文件
     * @param organizeCode 工厂
     * @return 文件信息
     */
    @ApiOperation(value = "上传文件", notes = "上传文件")
    SysFile uploadFile(MultipartFile file, String organizeCode);

    /**
     * 获取文件地址
     * @param config 配置
     * @param fileDb 文件信息
     * @return 文件地址
     */
    @ApiOperation(value = "获取文件地址", notes = "获取文件地址")
    String getFileUrl(MesConfig config, MesFile fileDb);
}
