package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesPersonCheckDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.PersonCheckModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCell;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/02/04 19:25
 * @Description:
 **/
public interface IPersonCheckDetailService {
    /**
     * 查询人员点检明细
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "查询人员点检明细", notes = "查询人员点检明细")
    PersonCheckModel queryPersonCheckDetail(MesPersonCheckDetail personCheckDetail);


    /**
     * 人员点检作业
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "人员点检作业", notes = "人员点检作业")
    void updatePersonCheckDetail(MesPersonCheckDetail personCheckDetail);

    /**
     * 关闭人员点检详情
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "关闭人员点检详情", notes = "关闭人员点检详情")
    void updatePersonCheckClose(MesPersonCheckDetail personCheckDetail);

    /**
     * 工位录入作业人员
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "工位录入作业人员", notes = "工位录入作业人员")
    void updateTaskUserByCell(MesPersonCheckDetail personCheckDetail);

    /**
     * 通过单据编号查询工位
     *
     * @param orderNo
     * @param organizeCode
     * @return
     */
    @ApiOperation(value = "通过单据编号查询工位", notes = "通过单据编号查询工位")
    List<MesWorkCell> queryCellByOrderNo(String orderNo, String organizeCode);
}
