package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesKeyPartData;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProdBindRecordExt;
import cn.estsh.i3plus.pojo.mes.bean.MesProdBindRecord;
import cn.estsh.impp.framework.boot.exception.ImppBusiException;
import io.swagger.annotations.ApiOperation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Description:
 * @Reference:
 * @Author: wangjie
 * @CreateDate: 2019/11/12 14:42
 * @Modify:
 **/
public interface IProdBindRecordExtService {

    /**
     * 插入产品绑定记录拓展表(新事务，不回滚)
     *
     * @param prodBindRecordExt 绑定记录拓展
     */
    @ApiOperation(value = "插入产品绑定记录拓展表(新事务，不回滚)", notes = "插入产品绑定记录拓展表(新事务，不回滚)")
    @Transactional(propagation = Propagation.REQUIRES_NEW, noRollbackFor = {ImppBusiException.class, Exception.class})
    void insertProdBindRecordExtNoRollback(MesProdBindRecordExt prodBindRecordExt);

    /**
     * 根据工单号，条码获取已绑数据
     * @param organizeCode 组织代码
     * @param workOrderNo 工单号
     * @param serialNumber 产品条码
     * @return 已绑数据
     */
    @ApiOperation(value = "根据工单号，条码获取已绑数据", notes = "根据工单号，条码获取已绑数据")
    List<MesProdBindRecordExt> getProdBindRecordExtList(String organizeCode, String workOrderNo, String serialNumber);

    /**
     * 根据工单号,条码,工位代码获取已绑数据
     * @param organizeCode 组织代码
     * @param workOrderNo 工单号
     * @param serialNumber 产品条码
     * @param workCellCode 工位代码
     * @return 已绑数据
     */
    @ApiOperation(value = "根据工单号,条码,工位代码获取已绑数据", notes = "根据工单号,条码,工位代码获取已绑数据")
    List<MesProdBindRecord> getProdBindRecordList(String organizeCode, String workOrderNo, String serialNumber, String workCellCode);


    /**
     * 插入产品绑定记录拓展表(新事务，不回滚)
     *
     * @param prodBindRecordExt 绑定记录拓展
     */
    @ApiOperation(value = "插入绑定关键件信息记录拓展表", notes = "插入绑定关键件信息记录拓展表")
    @Transactional(propagation = Propagation.REQUIRES_NEW, noRollbackFor = {ImppBusiException.class, Exception.class})
    MesKeyPartData insertKeyPartData(MesKeyPartData keyPartAndRfidRecord, String userName, MesProdBindRecordExt prodBindRecordExt, MesKeyPartData partAndRfidRecord, Integer flag, Integer operationType);
}
