package cn.estsh.i3plus.ext.mes.pcn.api.base;

import cn.estsh.i3plus.ext.mes.pcn.pojo.model.SxWorkCellModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCell;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/1/29 13:24
 **/
public interface ISxOrganizeExtService {

    /**
     * 根据生产线代码查询工位集合
     * @param organizeCode 组织代码
     * @param workCenterCode 生产线代码
     * @return 工位集合
     */
    @ApiOperation(value = "根据生产线代码查询工位集合", notes = "根据生产线代码查询工位集合")
    List<MesWorkCell> findWorkCell(String organizeCode, String workCenterCode);

    /**
     * 查询工位分页集合数据
     * @param workCellModel 查询条件
     * @param pager 分页条件
     * @return 工位分页集合数据
     */
    @ApiOperation(value = "工程不良分类统计月报日报", notes = "工程不良分类统计月报日报")
    ListPager<SxWorkCellModel> queryValidWorkCellListPage(SxWorkCellModel workCellModel, Pager pager);
}
