package cn.estsh.i3plus.ext.mes.pcn.api.base.bu;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesBusiConfig;
import io.swagger.annotations.ApiOperation;

import java.util.Map;

/**
 * @Author: xinwang.yi
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IMesBusiConfigService {

    /**
     * 根据配置代码获取业务配置表信息
     *
     * @param cfgCode 配置代码
     * @return 业务配置数据
     */
    @ApiOperation(value = "根据配置代码获取业务配置表信息", notes = "根据配置代码获取业务配置表信息")
    MesBusiConfig queryBusiConfigeByCfgCode(String cfgCode, String organizeCode);

    /**
     * 获取配置信息MAP
     * @param organizeCode 组织代码
     * @param cfgCode 配置代码
     * @return 配置信息MAP
     */
    @ApiOperation(value = "获取配置信息MAP", notes = "获取配置信息MAP")
    Map<String, String> getConfigMap(String organizeCode, String cfgCode);
}
