package cn.estsh.i3plus.ext.mes.pcn.api.base.bu3;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOuterPackageDetail;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IMesOuterPackageDetailService {

    /**
     * 根据内包装条码获取已绑定的外包装条码信息集合
     * @param organizeCode 组织代码
     * @param workOrderNo 工单号
     * @param packageNo 内包装条码
     * @return 物料BOM信息集合
     */
    @ApiOperation(value = "根据工单号、内包装条码获取已绑定的外包装条码信息集合", notes = "根据工单号、内包装条码获取已绑定的外包装条码信息集合")
    MesOuterPackageDetail getBoundOuterPackDetailByWorkOrderNoAndPackNo(String organizeCode, String workOrderNo, String packageNo);

    /**
     * 根据内包装条码获取已绑定的外包装条码信息集合
     * @param organizeCode 组织代码
     * @param workOrderNo 工单号
     * @return 物料BOM信息集合
     */
    @ApiOperation(value = "根据工单号获取已绑定的外包装条码信息集合", notes = "根据工单号获取已绑定的外包装条码信息集合")
    List<MesOuterPackageDetail> findBoundOuterPackDetailByWorkOrderNo(String organizeCode, String workOrderNo);
}
