package cn.estsh.i3plus.ext.mes.pcn.api.base.bu3;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesReworkRange;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.bu3.SxReworkRangeModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;
import java.util.Map;

/**
 * @Author: xinwang.yi
 * @CreateDate: 2023/06/14 10:06 上午
 * @Description: 返工范围
 **/
public interface ISxReworkRangeService {

    /**
     * 按条件分页查询返工范围
     *
     * @param reworkRange 查询条件
     * @return 工单信息
     */
    //@ApiOperation(value = "按条件分页查询返工范围", notes = "按条件分页查询返工范围")
    //ListPager<MesReworkRange> queryMesReworkRangeByPager(MesReworkRange reworkRange, Pager pager);

    /**
     * 根据工单号、作业时间、班次获取返工范围信息
     *
     * @param organizeCode 工厂
     * @param workOrderNo 区域代码
     * @param workTime 作业时间
     * @param shiftCode 班次代码
     * @return 工单信息
     */
    @ApiOperation(value = "根据工单号、作业时间、班次获取返工范围信息", notes = "根据工单号、作业时间、班次获取返工范围信息")
    List<MesReworkRange> queryMesReworkRangeList(String organizeCode, String workOrderNo, String workTime, String shiftCode);

    /**
     * 根据物料编码获取未关联返工范围数据
     *
     * @param params 查询参数
     * @return 工单信息
     */
    @ApiOperation(value = "根据物料编码获取未关联返工范围数据", notes = "根据物料编码获取未关联返工范围数据")
    List<SxReworkRangeModel> queryNotBindStatusMesReworkRangeList(Map<String, Object> params);
}
