package cn.estsh.i3plus.ext.mes.pcn.api.base.jx;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesManageCode;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xinwang.yi
 * @CreateDate: 2023/10/13 13:06 下午
 * @Description:
 **/
public interface IMesManageCodeService {

    /**
     * 根据管理编码获取管理码信息
     * @param organizeCode 组织代码
     * @param manageCode 管理编码
     * @return 管理码信息
     */
    @ApiOperation(value = "根据管理编码获取管理码信息", notes = "根据管理编码获取管理码信息")
    MesManageCode getManageCode(String organizeCode, String manageCode);

    /**
     * 根据管理编码集合获取管理码信息集合
     * @param organizeCode 组织代码
     * @param manageCodeList 管理编码集合
     * @return 管理码信息集合
     */
    @ApiOperation(value = "根据管理编码集合获取管理码信息集合", notes = "根据管理编码集合获取管理码信息集合")
    List<MesManageCode> getManageCodeListByManageCodeList(String organizeCode, List<String> manageCodeList);
}
