package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOutPutStatistics;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IOutPutStatisticsService {

    /**
     * 获取产量统计信息
     * @param outPutStatistics 查询条件
     * @return 产量统计信息
     */
    @ApiOperation(value = "获取产量统计信息", notes = "获取产量统计信息")
    MesOutPutStatistics getOutPutStatistics(MesOutPutStatistics outPutStatistics);

    /**
     * 根据时间与工单获取产量统计信息
     * @param organizeCode 组织代码
     * @param workOrderNo 生产工单号
     * @param workTime 作业时间
     * @param shiftCode 班次代码
     * @return 产量统计信息
     */
    @ApiOperation(value = "根据时间与工单获取产量统计信息", notes = "根据时间与工单获取产量统计信息")
    MesOutPutStatistics getOutPutStatisticsByTimeAndOrderNo(String organizeCode, String workOrderNo, String workTime, String shiftCode);
}
