package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesPartExt;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MatchRuleCodeModel;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description: 编码规则
 **/
public interface IProductEncodeCfgExtService {

    /**
     * 获取编码规则
     * @param organizeCode 组织代码
     * @param codeType 编码类型
     * @param partDb 物料信息
     * @param workCenterCode 生产线代码
     * @return 编码规则代码
     */
    @ApiOperation(value = "获取编码规则", notes = "获取编码规则")
    String getRuleCodeByMatchType(String organizeCode, Integer codeType, MesPartExt partDb, String workCenterCode);

    /**
     * 获取编码规则
     * @param matchRuleCodeModel 编码配置信息
     * @return 编码规则代码
     */
    @ApiOperation(value = "获取编码规则", notes = "获取编码规则")
    String getRuleCodeByMatchType(MatchRuleCodeModel matchRuleCodeModel);

}
