package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOutPutStatistics;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOutPutStatisticsTravel;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface ISxOutPutStatisticsTravelService {

    /**
     * 插入产量统计履历
     * @param outPutStatistics 产量统计信息
     * @return 产量统计履历
     */
    @ApiOperation(value = "插入产量统计履历", notes = "插入产量统计履历")
    MesOutPutStatisticsTravel insertOutPutStatisticsTravel(MesOutPutStatistics outPutStatistics);

    /**
     * 查询最大序号产量统计履历
     * @return
     */
    @ApiOperation(value = "查询最大序号产量统计履历", notes = "查询最大序号产量统计履历")
    MesOutPutStatisticsTravel getMaxSeqOutPutStatisticsTravel(String organizeCode, String workOrderNo, String shiftCode, String workTime);

    /**
     * 删除产量统计履历数据
     * @param organizeCode 工厂代码
     * @param modifyDatetime 修改时间
     * @return
     */
    @ApiOperation(value = "删除产量统计履历数据", notes = "删除产量统计履历数据")
    void deleteOutPutStatisticsTravel(String organizeCode, String modifyDatetime);

}
