package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesWorkCellPrintRecordDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.PrintRecordDetailModel;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import io.swagger.annotations.ApiOperation;

import java.util.List;

public interface ISxPrintRecordService {

    /**
     * 查询打印记录分页数据
     * @param detail 查询条件
     * @param pager 分页条件
     * @return 打印记录分页数据
     */
    @ApiOperation(value = "查询打印记录分页数据", notes = "查询打印记录分页数据")
    ListPager queryPrinterRecordListPager(MesWorkCellPrintRecordDetail detail, Pager pager);

    /**
     * 查询打印记录明细集合
     * @param organizeCode 组织代码
     * @param sn 条码
     * @param tagType 标签类型
     * @return 打印记录明细集合
     */
    @ApiOperation(value = "查询打印记录明细集合", notes = "查询打印记录明细集合")
    List<PrintRecordDetailModel> queryPrinterRecordDetailList(String organizeCode, String sn, Integer tagType);
}
