package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesWorkOrderExt;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesWorkOrderTravel;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface ISxWorkOrderTravelService {

    /**
     * 插入工单履历
     * @param workOrderExt 工单信息
     * @return 工单履历
     */
    @ApiOperation(value = "插入工单履历", notes = "插入工单履历")
    MesWorkOrderTravel insertWorkOrderTravel(MesWorkOrderExt workOrderExt);

    /**
     * 查询最大序号工单履历
     * @return
     */
    @ApiOperation(value = "查询最大序号工单履历", notes = "查询最大序号工单履历")
    MesWorkOrderTravel getMaxSeqWorkOrderTravel(String organizeCode, String orderNo);

    /**
     * 删除指定时间范围内的工单履历数据
     * @Param organizeCode 工厂代码
     * @Param modifyDatetime 修改时间
     * @return
     */
    @ApiOperation(value = "删除指定时间范围内的工单履历数据", notes = "删除指定时间范围内的工单履历数据")
    void deleteWorkOrderTravel(String organizeCode, String modifyDatetime);

}
