package cn.estsh.i3plus.ext.mes.pcn.api.busi;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesWorkOrderExt;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesWorkOrderLogExt;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderLog;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/19 15:06 下午
 * @Description:
 **/
public interface IWorkOrderLogExtService {

    /**
     * 插入工单日志
     * @param workOrderExt 工单信息
     * @return 工单日志信息
     */
    @ApiOperation(value = "插入工单日志", notes = "插入工单日志")
    MesWorkOrderLogExt insertMesWorkOrderLogExt(MesWorkOrderExt workOrderExt);

    /**
     * 根据工单编码获取工单日志集合
     * @param organizeCode 组织代码
     * @param orderNo 工单编码
     * @return 工单日志集合
     */
    @ApiOperation(value = "根据工单编码获取工单日志集合", notes = "根据工单编码获取工单日志集合")
    List<MesWorkOrderLogExt> getWorkOrderLogExtList(String organizeCode, String orderNo);

    /**
     * 根据工单编码获取工单日志集合
     * @param organizeCode 组织代码
     * @param orderNo 工单编码
     * @return 工单日志集合
     */
    @ApiOperation(value = "根据工单编码获取工单日志集合", notes = "根据工单编码获取工单日志集合")
    List<MesWorkOrderLog> getWorkOrderLogList(String organizeCode, String orderNo);

    /**
     * 删除指定工单类型和时间范围工单日志
     * @param organizeCode 组织代码
     * @param workOrderStatusList 工单状态集合
     * @return 工单日志集合
     */
    @ApiOperation(value = "删除指定工单类型和时间范围工单日志", notes = "删除指定工单类型和时间范围工单日志")
    void deleteWorkOrderLogExt(String organizeCode, List<Integer> workOrderStatusList, String modifyDatetime);

}
