package cn.estsh.i3plus.ext.mes.pcn.api.busi.bu;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOuterPackage;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOuterPackageDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProduceSnExt;
import io.swagger.annotations.ApiOperation;

import java.util.List;

public interface IOuterPackageSnService {

    /**
     * 根据小包装条码查询大包装条码表
     * @param organizeCode 组织代码
     * @param packageNo 小包装条码
     * @return 条码集合
     */
    @ApiOperation(value = "小包装条码查询大包装条码表明细表集合", notes = "小包装条码查询大包装条码表明细表集合")
    List<MesOuterPackageDetail> getOuterPackageDetailListByPackageNo(String organizeCode, String packageNo);

    /**
     * 生成大包装条码
     * @param workerOrderNo
     * @param organizeCode
     * @param userInfo
     */
    String doHandCreateOuterPackageSn(List<String> packageNoList,String workerOrderNo, String organizeCode, String userInfo);


    /**
     * 通过组织机构号，大包装条码查询得到大包装对象
     *
     */
    List<MesOuterPackage> getOuterPackageListByPackageNo(String organizeCode, String packageNo);

    /**
     *  通过大包装条码查询大包装明细表数据
     * @param organizeCode
     * @param outerPackageNo
     * @return
     */
    List<MesOuterPackageDetail> getOuterPackageDetailListByOuterPackageNo(String organizeCode, String outerPackageNo);

    /**
     *  通过工单号查询大包装明细表数据
     * @param organizeCode
     * @param workOrderNo
     * @return
     */
    List<MesOuterPackageDetail> getOuterPackageDetailListByWorkOrderNo(String organizeCode, String workOrderNo);

}
