package cn.estsh.i3plus.ext.mes.pcn.api.busi.bu3;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesPersonCheckDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesWorkLicense;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: xinwang.yi
 * @CreateDate: 2023/04/14 10:25
 * @Description:
 **/
public interface IBuPersonCheckDetailService {

    /**
     * 工位录入作业人员
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "工位录入作业人员", notes = "工位录入作业人员")
    void updateTaskUserByCell(MesPersonCheckDetail personCheckDetail);

    /**
     * 根据上岗证编码获取作业人姓名
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "根据上岗证编码获取作业人姓名", notes = "根据上岗证编码获取作业人姓名")
    MesWorkLicense getTaskUserByWorkLicenseCode(MesPersonCheckDetail personCheckDetail);

    /**
     * 校验上岗证有效期
     * @param workLicenseCode 上岗证编码
     * @param workLicenseDb 上岗证
     * @return
     */
    @ApiOperation(value = "校验上岗证有效期", notes = "校验上岗证有效期")
    String checkWorkLicenseValidityDate(String workLicenseCode, MesWorkLicense workLicenseDb);

}
