package cn.estsh.i3plus.ext.mes.pcn.api.busi.bu3;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProduceSnRepair;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.bu3.SxPackSnReportModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xinwang.yi
 * @CreateDate: 2023/07/04 15:06 下午
 * @Description:
 **/
public interface ISxReworkOrderService {

    /**
     * 缓存作业指导书生产线切替数量配置信息
     * @param organizeCode 工厂代码
     * @param woStatus 工单状态
     * @param workOrderNoList 工单号集合
     * @return 切替数量
     */
    @ApiOperation(value = "修改工单状态", notes = "修改工单状态")
    void updateReworkOrderStatus(String organizeCode, String userName, String nowTime, Integer woStatus, List<String> workOrderNoList);

    /**
     * 根据工单号获取返工条码
     * @param organizeCode 工厂代码
     * @param workOrderNo 工单号
     * @return 切替数量
     */
    @ApiOperation(value = "根据工单号获取返工条码", notes = "根据工单号获取返工条码")
    List<MesProduceSnRepair> queryMesProduceSnRepairList(String organizeCode, String workOrderNo);



    /**
     * 正常工单包装条码
     * @param model 查询条件
     * @return  正常工单包装条码
     */
    @ApiOperation(value = "正常工单包装条码", notes = "正常工单包装条码")
    List<SxPackSnReportModel> queryStandardWorkOrderPackSn(SxPackSnReportModel model);
}
