package cn.estsh.i3plus.ext.mes.pcn.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProduceSnExt;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import io.swagger.annotations.ApiOperation;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/18 11:22 上午
 * @Description:
 **/
public interface IJxProduceSnExtService {

    /**
     * 根据过程条码或者产品条码查询产品条码信息
     * @param organizeCode 组织代码
     * @param serialNumber 过程条码
     * @param productSn    产品条码
     * @return 产品条码信息
     */
    @ApiOperation(value = "根据过程条码或者产品条码查询产品条码信息", notes = "根据过程条码或者产品条码查询产品条码信息")
    MesProduceSnExt getProduceSnExtDb(String organizeCode, String serialNumber, String productSn);

    /**
     * 设置条码产线 工位 工序 下一道工序
     * @param reqBean        工位对象数据
     * @param produceSnExt   条码信息
     */
    @ApiOperation(value = "设置条码产线 工位 工序 下一道工序", notes = "设置条码产线 工位 工序 下一道工序")
    void doPackSnExtProcess(StationRequestBean reqBean, MesProduceSnExt produceSnExt);

}
