package cn.estsh.i3plus.ext.mes.pcn.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesManageCode;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProduceSnMcRecord;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/18 11:22 上午
 * @Description:
 **/
public interface IJxProduceSnMcRecordService {

    /**
     * 根据管理码,生产线代码查询管理码信息
     * @param organizeCode 组织代码
     * @param manageCode 管理码
     * @param workCenterCode 生产线代码
     * @return 管理码信息
     */
    @ApiOperation(value = "根据管理码,生产线代码查询管理码信息", notes = "根据管理码,生产线代码查询管理码信息")
    MesManageCode getManageCodeDb(String organizeCode, String manageCode, String workCenterCode);

    /**
     * 根据生产工单查询管理码与工单条码关系信息
     * @param organizeCode 组织代码
     * @param workOrderNo 生产工单
     * @return 管理码与工单条码关系信息
     */
    @ApiOperation(value = "根据生产工单查询产品管理码与工单条码关系信息", notes = "根据生产工单查询产品管理码与工单条码关系信息")
    List<MesProduceSnMcRecord> getProduceSnMcRecordDbList(String organizeCode, String workOrderNo);

    /**
     * 根据管理码查询管理码与工单条码关系信息
     * @param organizeCode 组织代码
     * @param manageCode 管理码
     * @return 管理码与工单条码关系信息
     */
    @ApiOperation(value = "根据管理码查询管理码与工单条码关系信息", notes = "根据管理码查询管理码与工单条码关系信息")
    MesProduceSnMcRecord getProduceSnMcRecordDb(String organizeCode, String manageCode);

}
