package cn.estsh.i3plus.ext.mes.pcn.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesProcessTorqueManageTaskDetail;
import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkCell;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: xinwang.yi
 * @CreateDate: 2023/14/32 14:25
 * @Description:
 **/
public interface ITorqueManageCheckService {
    /**
     * 查询扭矩管理点检明细
     * @param personCheckDetail
     * @return
     */
    @ApiOperation(value = "查询扭矩管理点检明细", notes = "查询扭矩管理点检明细")
    ListPager<MesProcessTorqueManageTaskDetail> queryTorqueManageCheckDetail(MesProcessTorqueManageTaskDetail personCheckDetail, Pager pager);


    /**
     * 扭矩管理点检作业
     * @param torqueManageTaskDetail
     * @return
     */
    @ApiOperation(value = "扭矩管理点检作业", notes = "扭矩管理点检作业")
    void updateTorqueManageCheckDetail(MesProcessTorqueManageTaskDetail torqueManageTaskDetail);

    /**
     * 扭矩管理点检作业
     * @param torqueManageTaskDetail
     * @return
     */
    @ApiOperation(value = "根据单号修改明细数据中扭矩规格值和管理NO", notes = "根据单号修改明细数据中扭矩规格值和管理NO")
    void updateTopTorqueManageCheckDetail(MesProcessTorqueManageTaskDetail torqueManageTaskDetail);


    /**
     * 通过单据编号查询工位
     *
     * @param orderNo
     * @param organizeCode
     * @return
     */
    @ApiOperation(value = "通过单据编号查询工位", notes = "通过单据编号查询工位")
    List<MesWorkCell> queryCellByOrderNo(String orderNo, String organizeCode);
}
