package cn.estsh.i3plus.ext.mes.pcn.apiservice.dao;



import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesPartCheckDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.PartCheckDetailModel;
import cn.estsh.i3plus.pojo.base.common.Pager;

import java.util.List;

/**
 * @Description : 物料点检明细Dao
 * @Reference :
 * @Author : xiangming.liao
 * @CreateDate : 2020-02-21
 * @Modify:
 **/
public interface IPartCheckDao {

    /**
     * 查询物料明细数量
     * @param partCheckDetail 物料明细
     * @return 数量
     */
    int queryPartCheckByPagerCount(MesPartCheckDetail partCheckDetail);

    /**
     * 查询物料点检明细集合
     * @param partCheckDetail 查询条件
     * @param pager 分页条件
     * @return 物料信息集合
     */
    List<PartCheckDetailModel> queryPartCheckByPager(MesPartCheckDetail partCheckDetail, Pager pager);
}
