package cn.estsh.i3plus.ext.mes.pcn.apiservice.dao;

import cn.estsh.i3plus.ext.mes.pcn.pojo.model.ProduceSnExtModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.ProduceSnRepairModel;
import cn.estsh.i3plus.pojo.base.common.Pager;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2019/11/21 11:28 上午
 * @Description:
 **/
public interface IProduceSnRepairDao {

    /**
     * 查询返工条码数量
     * @param produceSnExtModel 查询条件
     * @return 返工条码数量
     */
    int queryProduceSnRepairByPagerCount(ProduceSnExtModel produceSnExtModel);

    /**
     * 查询返工条码分页集合
     * @param produceSnExtModel 查询条件
     * @param pager 分页条件
     * @return 返工条码信息分页集合
     */
    List<ProduceSnExtModel> queryProduceSnRepairByPager(ProduceSnExtModel produceSnExtModel, Pager pager);

    /**
     * 查询返工条码集合
     * @param produceSnExtModel 查询条件
     * @return 返工条码信息集合
     */
    List<ProduceSnExtModel> queryProduceSnRepairList(ProduceSnExtModel produceSnExtModel);

    /**
     * 查询返工条码关联包装条码集合
     * @param produceSnExtModel 查询条件
     * @return 返工条码关联包装条码信息集合
     */
    List<ProduceSnExtModel> queryProduceSnRepairAndPackageNoList(ProduceSnExtModel produceSnExtModel);

    /**
     * 查询返工条码,包装条码,容器代码信息集合
     * @param organizeCode 组织代码
     * @param workOrderNo  生产工单号
     * @return 返工条码,包装条码,容器代码信息集合
     */
    List<ProduceSnRepairModel> queryRepairSnCtNoWithPackageNoListByWorkOrderNo(String organizeCode, String workOrderNo);

}
