package cn.estsh.i3plus.ext.mes.pcn.apiservice.dao.ep;

import cn.estsh.i3plus.ext.mes.pcn.pojo.model.ep.EpProduceSnExtModel;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2019/11/21 11:28 上午
 * @Description:
 **/
public interface IEpProduceSnExtDao {

    /**
     * 根据包装条码查询出货检验产品条码集合
     * @param organizeCode 组织代码
     * @param packageNo 包装条码
     * @return 查询产品条码集合
     */
    List<EpProduceSnExtModel> querySnListByPackNo4Oqc(String organizeCode, String packageNo);

    /**
     * 根据生产工单号,生产日期,班次代码查询出货检验产品条码集合
     * @param organizeCode 组织代码
     * @param workOrderNo 生产工单号
     * @param workTime 生产日期
     * @param shiftCode 班次代码
     * @return 查询产品条码集合
     */
    List<EpProduceSnExtModel> querySnListByOrderNoAndWorkTime4Oqc(String organizeCode, String workOrderNo, String workTime, String shiftCode);

}
