package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi.step.ep;

import cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi.station.ep.EpPartDivulgeCheckModuleService;
import cn.estsh.i3plus.mes.pcn.serviceimpl.base.BaseStepService;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-dev
 * @DESCRIPTION: 24小时泄露检测初始化工步
 * @USER: xinwang.yi
 * @DATE: 2021-12-21 13:30
 */
@Slf4j
@Service("epPartDivulgeCheckInitStepService")
public class EpPartDivulgeCheckInitStepService extends BaseStepService {

    @Autowired
    private EpPartDivulgeCheckModuleService partDivulgeCheckModuleService;

    @Override
    public StepResult execute(StationRequestBean reqBean) {
        log.info("epPartDivulgeCheckInitStepService[execute] 参数：{}", reqBean);
        partDivulgeCheckModuleService.init(reqBean);
        return StepResult.getSuccessComplete();
    }
}
