package cn.estsh.i3plus.ext.mes.pcn.apiservice.util.reader;

import oracle.sql.ARRAY;

/**
 * @author ns
 * @create 2021/11/25 0025 下午 15:20
 */
public class ReaderConstWords {
    /**
     * 引导码,固定为40H
     */
    public final static byte REQUEST_BOOT_CODE = 0x40;

    /**
     * 响应结果 成功 固定为F0H
     */
    public final static byte RESPONSE_BOOT_CODE_SUCCESS = (byte) 0xF0;
    /**
     *  响应结果 失败 固定为F4H
     */
    public final static byte RESPONSE_BOOT_CODE_FAIL = (byte) 0xF4;

    /**
     *  响应结果 byte数组的最短长度
     */
    public final static int RESPONSE_BYTE_ARRAY_MIN_LENGTH = 5;

    /**
     * 连接默认超时时间 3000ms
     */
    public final static int DEFAULT_CONNECT_TIMEOUT = 3000;

    /**
     * 读卡器默认端口
     */
    public final static int DEFAULT_PORT = 1969;


    /**
     * 读取命令
     */
    public final static byte READ_TAG_COMMAND = (byte) 0xEC;


    /**
     * 读取命令
     */
    public final static byte LIST_TAG_COMMAND = (byte) 0xEE;

//
//    /**
//     * 默认数据区 03 用户区
//     */
//    public final static byte DEFAULT_DATA_AREA =  0x03;

    /**
     * 默认数据区 01 EPC区
     */
    public final static byte DEFAULT_DATA_AREA =  0x01;

    /**
     * 数据区 00 密码区
     */
    public final static byte DATA_AREA_PASSWORD =  0x00;


    /**
     * 数据区 01 EPC区
     */
    public final static byte DATA_AREA_EPC =  0x01;


    /**
     * 数据区 02 TId区
     */
    public final static byte DATA_AREA_TID =  0x02;


    /**
     * 数据区 03 用户区
     */
    public final static byte DATA_AREA_USER =  0x03;

    /**
     * 默认 byte0
     */
    public final static byte BYTE_ZERO =  0x00;


    /**
     * 默认 byte 1
     */
    public final static byte BYTE_ONE =  0x01;

    /**
     * 默认 byte数组
     */
    public final static byte[] BYTE_EMPTY_ARRAY =  new byte[]{BYTE_ZERO};

    /**
     * int 转byte屏蔽高位
     */
    public final static byte INT_TO_BYTE_MASK = (byte) 0xFF;


    /**
     * 默认 accessPasswork
     */
    public final static Byte[] DEFAULT_ACCESS_PASSWORD =  new Byte[]{0x00,0x00,0x00,0x00};



}
