package cn.estsh.i3plus.ext.mes.pcn.icloud.sdk;

import cn.estsh.i3plus.ext.mes.pcn.icloud.sdkfallback.MesPcnBaseDataSyncFactory;
import cn.estsh.i3plus.platform.common.util.MesPcnConstWords;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

/**
 * @Description : 微服消息服务调用
 * @Reference :
 * @Author : yiming.gu
 * @CreateDate : 2019-04-24 15:40
 * @Modify:
 **/
@FeignClient(name = "i3mes-pcn", //对应配置文件中的spring.application.name
        path = MesPcnConstWords.BASE_CONTROLLER_PATH,
        fallbackFactory = MesPcnBaseDataSyncFactory.class)
public interface IMesPcnBaseDataSyncCloud {

    @GetMapping("/test-get-by-service")
    @ApiOperation(value = "PCN获取MES主服务数据")
    BaseResultBean getUser();

}
