package cn.estsh.i3plus.ext.mes.pcn.icloud.sdk;

import cn.estsh.i3plus.ext.mes.pcn.icloud.sdkfallback.IQmsCommonFallbackFactory;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import cn.estsh.impp.framework.base.service.ICommonService;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @Description : 通用微服务
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2023/4/18 10:20
 * @Modify:
 **/
@FeignClient(name="i3qms", //对应配置文件中的spring.application.name
        path= CommonConstWords.BASE_URL_QMS,
        fallbackFactory = IQmsCommonFallbackFactory.class
)
public interface IQmsCommonCloud extends ICommonService {

    /**
     * 查询制造点检样本台账结果给mes
     * @param organizeCode
     * @param proLineCode
     * @return
     */
    @GetMapping(value = "/comm/sx-qms-point-sample/find")
    BaseResultBean findPointSampleLedgerFomMes(@RequestParam(value = "organizeCode") String organizeCode,
                                               @RequestParam(value = "proLineCode", required = false) String proLineCode);
}
