package cn.estsh.i3plus.ext.mes.pcn.icloud.sdk;

import cn.estsh.i3plus.ext.mes.pcn.icloud.sdkfallback.WmsJobBookingFallbackFactory;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.MesWorkOverModel;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.bean.BaseResultBean;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "i3wms", //对应配置文件中的spring.application.name
        path = CommonConstWords.WHITELIST_URL,
        fallbackFactory = WmsJobBookingFallbackFactory.class
)
public interface IWmsJobBookingCloud {
    @PostMapping(value = "/base-data-ext/mes-work-over-scrap")
    BaseResultBean doMesWorkOver(@RequestBody List<MesWorkOverModel> wmsPsCheckModelList, @RequestParam("userName") String userName, @RequestParam("organizeCode") String organizeCode);
}
