package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/5 15:36
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_ANTI_STATIC_CHECK_DETAIL", indexes = {
        @Index(columnList = "ORDER_JOB_NO")
})
@Api("MES_防静电点检明细")
public class MesAntiStaticCheckDetail extends BaseBean implements Serializable {

    private static final long serialVersionUID = 3369878966902541947L;

    @Column(name = "ORDER_JOB_NO")
    @ApiParam("单据编号")
    private String orderJobNo;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("工作中心代码")
    private String workCenterCode;

    @Column(name = "WORK_CELL_CODE")
    @ApiParam(value = "工位代码")
    public String workCellCode;

    @Column(name = "WORK_CELL_NAME")
    @ApiParam("工位名称")
    private String workCellName;
    @Column(name = "SPOT_CHECK_USER")
    @ApiParam("点检人员")
    private String spotCheckUser;

    @Column(name = "SPOT_CHECK_TIME")
    @ApiParam("点检时间")
    private String spotCheckTime;

    @Column(name = "CHECK_Result")
    @ApiParam("点检结果")
    private Integer checkResult;

    @Column(name = "TEAM_CONFIRM_USER")
    @ApiParam("班组确认人")
    private String teamConfirmUser;

    @Column(name = "TEAM_CONFIRM_TIME")
    @ApiParam("班组确认时间")
    private String teamConfirmTime;

    @Column(name = "QUALITY_CONFIRM_USER")
    @ApiParam("品质确认人")
    private String qualityConfirmUser;

    @Column(name = "QUALITY_CONFIRM_TIME")
    @ApiParam("品质确认时间")
    private String qualityConfirmTime;

    @Column(name = "IS_TEAM_CONFIRM")
    @ApiParam("是否班组确认")
    private Integer isTeamConfirm = 20;

    @Column(name = "IS_QUALITY_CONFIRM")
    @ApiParam("是否品质确认")
    private Integer isQualityConfirm = 20;

    @Column(name = "remark")
    @ApiParam(value = "备注")
    public String remark;

    @Column(name = "BRACELET_CODE")
    @ApiParam(value = "防静电手环编码")
    public String braceletCode;
}
