package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年03月27日 15:09
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_BOM_TAKE_EFFECT_RECORD")
@Api("MES_BOM生效记录表")
public class MesBomTakeEffectRecord extends BaseBean implements Serializable {

    private static final long serialVersionUID = 5162638762307136038L;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("生产工单号")
    private String workOrderNo;

    @Column(name = "PART_NO")
    @ApiParam("物料号")
    private String partNo;

    @Column(name = "PART_NAME")
    @ApiParam("物料名称")
    private String partName;

    @Column(name = "PRODUCT_SN")
    @ApiParam("产品条码")
    private String productSn;

    @Column(name = "TASK_USER")
    @ApiParam("操作人")
    private String taskUser;

    @Column(name = "TAKE_EFFECT_TIME")
    @ApiParam("生效时间")
    private String takeEffectTime;


}
