package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Lob;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-bu
 * @DESCRIPTION: 业务配置表-作用1：供出货检验看板计划达成率 设定标准值
 * @USER: xinwang.yi
 * @DATE: 2022-07-07 16:06
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_BUSI_CONFIG")
@Api("MES_业务配置表")
public class MesBusiConfig extends BaseBean implements Serializable {

    private static final long serialVersionUID = -5324685224408785610L;
    @Column(name = "CFG_CODE")
    @ApiParam("配置代码")
    private String cfgCode;

    @Column(name = "CFG_NAME")
    @ApiParam("配置名称")
    private String cfgName;

    @Lob
    @Column(name = "CFG_VALUE")
    @ApiParam("配置值")
    private String cfgValue;

    @Column(name = "CFG_VALUE_SEQ")
    @ApiParam("配置键")
    private String cfgValueSeq;
}
