package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Lob;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/5 15:33
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_CHECK_ERROR_LOG")
@Api("MES_点检报错记录表")
public class MesCheckErrorLog extends BaseBean implements Serializable {


    private static final long serialVersionUID = -1304183558456922837L;

    @Column(name = "GENERATION_METHOD")
    @ApiParam("生成方式")
    private Integer generationMethod;

    @Column(name = "GENERATING_MODULE")
    @ApiParam(value = "生成模块")
    public String generatingModule;

    @Lob
    @Column(name = "ERROR_INFO")
    @ApiParam("描述")
    private String errorInfo;
}
