package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/26 14:05
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_CONTAINER_JOB_BOOKING")
@Api("MES_包装报工信息")
public class MesContainerJobBooking extends BaseBean implements Serializable {
    private static final long serialVersionUID = -2764664518874603089L;

    @ApiParam("容器编号")
    @Column(name = "CT_NO")
    private String ctNo;

    @ApiParam("包装物料")
    @Column(name = "PART_NO")
    private String partNo;

    @ApiParam("批次")
    @Column(name = "LOT_NO")
    private String lotNo;

    @ApiParam("数量")
    @Column(name = "QTY", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    private Double qty;

    @ApiParam("工单号")
    @Column(name = "WORK_ORDER_NO")
    private String workOrderNo;

    @ApiParam("包装号")
    @Column(name = "PACKAGE_NO")
    private String packageNo;


}
