package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_EMPLOYEE_AND_PROCESS_BIND")
@Api("人员与工序关系")
public class MesEmployeeAndProcessBind extends BaseBean implements Serializable {
    private static final long serialVersionUID = 4475936743523226080L;

    @Column(name = "EMPLOYEE_CODE")
    @ApiParam(value = "员工代码")
    private String employeeCode;

    @Column(name = "SKILL_KANBAN_PROCESS_CODE")
    @ApiParam(value = "技能看板工序代码(取【技能看板工序信息】中的工序代码)")
    private String skillKanbanProcessCode;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam(value = "产线代码(取组织模型菜单中的产线代码)")
    private String workCenterCode;

}
