package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_EMPLOYEE_NATURE")
@Api("员工性质")
public class MesEmployeeNature extends BaseBean implements Serializable {
    private static final long serialVersionUID = 7240177437222623968L;

    @Column(name = "EMPLOYEE_NATURE_CODE")
    @ApiParam(value = "员工性质代码")
    private String employeeNatureCode;

    @Column(name = "EMPLOYEE_NATURE_NAME")
    @ApiParam(value = "员工性质名称")
    private String employeeNatureName;

    @Column(name = "COLOR")
    @ApiParam(value = "颜色(颜色枚举：红底白字、蓝底黑字、灰底黑字、粉底黑字)")
    private String color;

}
