package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/2 13:23
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_EQUIPMENT_PARAM")
@Api("MES_设备点检")
public class MesEquipmentParam extends BaseBean implements Serializable {

    private static final long serialVersionUID = -2660123477447577792L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("工作中心代码")
    private String workCenterCode;

    @Column(name = "WORK_CELL_CODE")
    @ApiParam(value = "工位代码")
    public String workCellCode;

    @Column(name = "WORK_CELL_NAME")
    @ApiParam("工位名称")
    private String workCellName;

    @Column(name = "EQU_NO")
    @ApiParam("设备编号")
    private String equNo;

    @Column(name = "EQU_NAME")
    @ApiParam("设备名称")
    private String equName;

    @Column(name = "PARAM_NO")
    @ApiParam("参数编号")
    private String paramNo;

    @Column(name = "PARAM_DESC")
    @ApiParam("参数描述")
    private String paramDesc;

    @Column(name = "PARAM_VALUE")
    @ApiParam("参数值")
    private String paramValue;


}
