package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/2 13:23
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_FAIL_CASE_CHECK")
@Api("MES_失败事例点检")
public class MesFailCaseCheck extends BaseBean implements Serializable {
    private static final long serialVersionUID = -73188496348664118L;


    @Column(name = "PROCESS_CODE")
    @ApiParam(value = "工序代码")
    public String processCode;

    @Column(name = "PROCESS_NAME")
    @ApiParam("工序描述")
    private String processName;

    @Column(name = "PART_NO")
    @ApiParam("物料")
    private String partNo;

    @Column(name = "BAD_CONTENT")
    @ApiParam("不良内容")
    private String badContent;

    @Column(name = "STRATEGIES")
    @ApiParam("对应策略")
    private String strategies;

    @Column(name = "PUT_FORWARD")
    @ApiParam("提出方")
    private String putForward;

    @Column(name = "IMPL_DATE")
    @ApiParam("实施日")
    private String implDate;


}
