package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/7 13:31
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_FOUR_M_CHANGE")
@Api("MES_4M变化表")
public class MesFourMChange extends BaseBean implements Serializable {

    private static final long serialVersionUID = -3915758393342011554L;

    @Column(
            name = "MANAGE_TYPE"
    )
    @ApiParam("管理类型")
    private Integer manageType;

    @Column(
            name = "WORK_CENTER_CODE"
    )
    @ApiParam("工作中心代码")
    private String workCenterCode;

    @Column(
            name = "WORK_CELL_CODE"
    )
    @ApiParam(value = "工位代码")
    private String workCellCode;

    @Column(
            name = "BEFORE_CONTENT"
    )
    @ApiParam("变化前内容")
    private String beforeContent;

    @Column(
            name = "AFTER_CONTENT"
    )
    @ApiParam("变化后内容")
    private String afterContent;

    public MesFourMChange(String workCellCode, String beforeContent, String afterContent, Integer manageType) {
        this.workCellCode = workCellCode;
        this.beforeContent = beforeContent;
        this.afterContent = afterContent;
        this.manageType = manageType;
    }

    public MesFourMChange() {}
}
