package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/7 13:31
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_FOUR_M_DETAIL", indexes = {
        @Index(columnList = "ORDER_NO")
})
@Api("MES_4M管理表")
public class MesFourMDetail extends BaseBean implements Serializable {


    private static final long serialVersionUID = 6125210775391247001L;


    @Column(
            name = "MANAGE_TYPE"
    )
    @ApiParam("管理类型")
    private Integer manageType;

    @Column(
            name = "ORDER_NO"
    )
    @ApiParam("工单号")
    private String orderNo;

    @Column(
            name = "WORK_CENTER_CODE"
    )
    @ApiParam("工作中心代码")
    private String workCenterCode;

    @Column(
            name = "WORK_CELL_CODE"
    )
    @ApiParam(value = "工位代码")
    public String workCellCode;

    @Column(
            name = "BEFORE_CONTENT"
    )
    @ApiParam("变化前内容")
    private String beforeContent;

    @Column(
            name = "AFTER_CONTENT"
    )
    @ApiParam("变化后内容")
    private String afterContent;

    @ApiParam("项目管理代码")
    private String manageCode;

    @Column(
            name = "MANAGE_CONTENT"
    )
    @ApiParam("项目管理内容")
    private String manageContent;

    @Column(
            name = "CONFIRM_CODE"
    )
    @ApiParam("项目确认代码")
    private String confirmCode;

    @Column(
            name = "CONFIRM_CONTENT"
    )
    @ApiParam("项目确认内容")
    private String confirmContent;

    @Column(
            name = "FRIST_PRODUCT"
    )
    @ApiParam("首件品")
    private String fristProduct;

    @Column(
            name = "HANDLER_CONTENT"
    )
    @ApiParam("异常处理后内容")
    private String handlerContent;

    @Column(name = "TEAM_CONFIRM_USER")
    @ApiParam("班组确认人")
    private String teamConfirmUser;

    @Column(name = "TEAM_CONFIRM_TIME")
    @ApiParam("班组确认时间")
    private String teamConfirmTime;

    @Column(name = "QUALITY_CONFIRM_USER")
    @ApiParam("品质确认人")
    private String qualityConfirmUser;

    @Column(name = "QUALITY_CONFIRM_TIME")
    @ApiParam("品质确认时间")
    private String qualityConfirmTime;

    @Column(name = "IS_TEAM_CONFIRM")
    @ApiParam("是否班组确认")
    private Integer isTeamConfirm = 20;

    @Column(name = "IS_QUALITY_CONFIRM")
    @ApiParam("是否品质确认")
    private Integer isQualityConfirm = 20;

    @Transient
    @ApiParam(value = "物料编号")
    public String partNo;

    @Transient
    @ApiParam(value = "物料名称")
    public String partNameRdd;

}
