package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author steven.peng
 * @version 1.0
 * @date 2023-01-15
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_INNER_PACKAGE_TRAVEL")
@Api("MES_小包装履历表")
public class MesInnerPackageTravel extends BaseBean implements Serializable {

    @Column(
            name = "WORK_ORDER_NO"
    )
    @ApiParam("生产工单号")
    private String workOrderNo;
    @Column(
            name = "WORK_CENTER_CODE"
    )
    @ApiParam("工作中心代码")
    private String workCenterCode;
    @Column(
            name = "WORK_CELL_CODE"
    )
    @ApiParam("工作单元代码")
    private String workCellCode;

    @Column(name = "LAST_WORK_ORDER_NO")
    @ApiParam("最终工单号")
    private String lastWorkOrderNo;

    //EP专用
    @Column(name = "PART_LOT_NO")
    @ApiParam("成品批次号")
    public String partLotNo;

    @Column(name = "SHIFT_CODE")
    @ApiParam("班次代码")
    private String shiftCode;

    @Column(name = "WORK_TIME")
    @ApiParam("作业时间")
    private String workTime;

    @Column(name="ORGANIZE_CODE_EXT")
    @ApiParam(value ="组织代码")
    public String organizeCodeExt;

    @Column(name="IS_VALID_EXT")
    @ApiParam(value = "有效性")
    public Integer isValidExt;

    @Column(name="IS_DELETED_EXT")
    @ApiParam(value = "是否已删除")
    public Integer isDeletedExt;

    @Column(name="CREATE_USER_EXT")
    @ApiParam(value = "创建用户")
    public String createUserExt;

    @Column(name="CREATE_DATE_TIME_EXT")
    @ApiParam(value = "创建日期")
    public String createDatetimeExt;

    @Column(name="MODIFY_USER_EXT")
    @ApiParam(value = "修改人")
    public String modifyUserExt;

    @Column(name="MODIFY_DATE_TIME_EXT")
    @ApiParam(value = "修改日期")
    public String modifyDatetimeExt;

    @Column(name = "SYSTEM_SYNC_STATUS")
    @ColumnDefault("2")
    @ApiParam(value = "系统同步标志")
    public Integer systemSyncStatus = 2;

    @ApiParam("包装编号")
    private String packageNo;
    @Column(
            name = "PART_NO"
    )
    @ApiParam("物料号")
    private String partNo;

    @ApiParam("条码类型")
    private Integer snType;

}
