package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年08月21日 6:34
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_MANUAL_REPORT_TRAVEL")
@Api("MES_手动报工履历信息")
public class MesManualReportTravel extends BaseBean implements Serializable {

    private static final long serialVersionUID = 2979783006130877088L;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("生产工单号")
    private String workOrderNo;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("生产线代码")
    private String workCenterCode;

    @Column(name = "WORK_CENTER_NAME")
    @ApiParam("生产线名称")
    private String workCenterName;

    @Column(name = "SHIFT_CODE")
    @ApiParam("班次代码")
    private String shiftCode;

    @Column(name = "SHIFT_NAME")
    @ApiParam("班次名称")
    private String shiftName;

    @Column(name = "WORK_TIME")
    @ApiParam("作业日期")
    private String workTime;

    @Column(name = "PART_NO")
    @ApiParam("物料编码")
    private String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam("物料名称")
    private String partNameRdd;

    @Column(name = "QTY")
    @ApiParam("计划数量")
    private Double qty;

    @Column(name = "COMPLETE_QTY")
    @ApiParam("完成数量")
    private Double completeQty;

    @Column(name = "REPORT_QTY")
    @ApiParam("手动报工数量")
    private Double reportQty;

    @Column(name = "START_TIME")
    @ApiParam("计划开始时间")
    private String startTime;

    @Column(name = "END_TIME")
    @ApiParam("计划结束时间")
    private String endTime;

    @Column(name = "SYSTEM_SYNC_STATUS")
    @ColumnDefault("2")
    @ApiParam(value = "系统同步标志")
    public Integer systemSyncStatus = 2;


}
