package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @Description:
 * @Author: xinwang.yi
 * @Date: 2023/10/19 11:56
 * @Modify:
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_MANUL_EXECUTE_OUT_TRAVEL", indexes = {
        @Index(columnList = "WORK_ORDER_NO,WORK_CELL_CODE"),
        @Index(columnList = "SERIAL_NUMBER")
})
@Api("MES_手动强制放行履历表")
public class MesManulExecuteOutTravel extends BaseBean implements Serializable {

    private static final long serialVersionUID = -2989268758068809547L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam(value = "产线代码")
    private String workCenterCode;

    //@Column(name = "SHIFT_CODE")
    //@ApiParam("班次代码")
    //private String shiftCode;
    //
    //@Column(name = "WORK_TIME")
    //@ApiParam("作业时间")
    //private String workTime;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam(value = "生产工单号")
    public String workOrderNo;

    @Column(name = "PART_NO")
    @ApiParam("物料号")
    private String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam("物料名称")
    private String partNameRdd;

    @Column(name = "WORK_CELL_CODE")
    @ApiParam(value = "工位代码")
    public String workCellCode;

    @Column(name = "PROCESS_CODE")
    @ApiParam("工序代码")
    private String processCode;

    //@Column(name = "PROCESS_NAME_RDD")
    //@ApiParam("工序名称")
    //private String processNameRdd;

    @Column(name = "SERIAL_NUMBER")
    @ApiParam("过程条码")
    private String serialNumber;
}
