package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @Description:
 * @Author: xiangming.liao
 * @Date: 2021/01/14 20:03
 * @Modify:
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_ON_SITE_ORDER", indexes = {
        @Index(columnList = "ORDER_NO"),
        @Index(columnList = "WORK_ORDER_NO")
})
@Api("MES_巡检单")
public class MesOnSiteOrder extends BaseBean implements Serializable {

    private static final long serialVersionUID = 7654475809174434963L;

    @Column(name = "ORDER_NO")
    @ApiParam(value = "单号")
    private String orderNo;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam(value = "生产线")
    public String workCenterCode;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam(value = "生产工单号")
    public String workOrderNo;

    @Column(name = "PART_NO")
    @ApiParam(value = "物料编码")
    public String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam(value = "物料名称")
    public String partNameRdd;

    @Column(name = "ORDER_STATUS")
    @ApiParam(value = "单据状态")
    public Integer orderStatus;
}
