package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/1/27 16:44
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_PART_AUTO_LANDED", indexes = {
        @Index(columnList = "PART_NO")
})
@Api("MES_自动发布物料配置")
public class MesPartAutoLanded extends BaseBean implements Serializable {

    private static final long serialVersionUID = -2884183057964347886L;
    @Column(
            name = "WORK_CENTER_CODE",
            nullable = false
    )
    @ApiParam("生产线代码")
    private String workCenterCode;
    @Column(
            name = "PART_NO",
            nullable = false
    )
    @ApiParam("物料号")
    private String partNo;
    @Column(
            name = "PART_NAME_RDD"
    )
    @ApiParam("物料名称")
    private String partNameRdd;

}
