package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-bu
 * @DESCRIPTION:
 * @USER: xinwang.yi
 * @DATE: 2022-01-11 17:07
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "MES_PRINT_PART_PARAMETER_EXT", indexes = {
        @Index(columnList = "PART_NO"),
        @Index(columnList = "SYSTEM_SYNC_STATUS")
})
@Api("产品信息表")
public class MesPrintPartParameterExt extends BaseBean implements Serializable {

    private static final long serialVersionUID = 5721341172113574962L;

    @Column(name = "SYSTEM_SYNC_STATUS")
    @ColumnDefault("2")
    @ApiParam(value = "系统同步标志")
    public Integer systemSyncStatus = 2;

    @Column(name = "NET_WEIGHT")
    @ApiParam("净重")
    private String netWeight;

    @Column(name = "ROUGH_WEIGHT")
    @ApiParam("毛重")
    private String roughWeight;

    @Column(name = "PACKAGE_SIZE")
    @ApiParam("包装尺寸")
    private String packageSize;

    @Column(name = "PART_NO")
    @ApiParam("物料编码")
    private String partNo;

    @Column(name = "PART_NAME")
    @ApiParam("物料名称")
    private String partName;

}
