package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Author: wangjie
 * @CreateDate: 2019/7/30 9:30 AM
 * @Description:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_PRINTER_CFG")
@Api("打印机配置表")
public class MesPrinterCfg extends BaseBean implements Serializable {

    private static final long serialVersionUID = -7795261724110501551L;

    @Column(name="PRINTER_NO")
    @ApiParam("打印机编号")
    private String printerNo;

    @Column(name="PRINTER_NAME")
    @ApiParam("打印机名称")
    private String printerName;

    @Column(name="IP")
    @ApiParam("IP")
    private String ip;

    @Column(name="PORT")
    @ApiParam("端口")
    private Integer port;

    @Column(name="MEMO")
    @ApiParam(value ="描述")
    private String memo;

    @Column(name="POSITION")
    @ApiParam("位置")
    private String position;

}
