package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/02/03 9:35
 * @Description:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_PROCESS_CHECK")
@Api("工序点检项目")
public class MesProcessCheck extends BaseBean implements Serializable {
    private static final long serialVersionUID = 8680976232954849476L;

    @Column(name = "PROCESS_CODE")
    @ApiParam("工序代码")
    private String processCode;

    @Column(name = "PROCESS_NAME")
    @ApiParam("工序名称")
    private String processName;

    @Column(name = "CHECK_INFO")
    @ApiParam("点检信息")
    private String checkInfo;

    @Column(name="PART_NO")
    @ApiParam("物料编码")
    private String partNo;

}
