package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_PROCESS_LABEL_MARKING")
@Api("工序标签标示")
public class MesProcessLabelMarking extends BaseBean implements Serializable {
    private static final long serialVersionUID = -760601615376506804L;

    @Column(name = "PROCESS_LABEL_CODE")
    @ApiParam(value = "工序标签标示代码")
    private String processLabelCode;

    @Column(name = "PROCESS_LABEL_NAME")
    @ApiParam(value = "工序标签标示名称")
    private String processLabelName;

    @Column(name = "COLOR")
    @ApiParam(value = "颜色(颜色枚举：黄底红字、黄底白字、黄底黑字、灰底黑字)")
    private String color;

    @Column(name = "LOCATION")
    @ApiParam(value = "位置(位置枚举：左上、左下、右上、右下)")
    private String location;

}
