package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.mes.bean.MesProdPack;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/12 15:58
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_PROD_PACK_EXT", indexes = {
        @Index(columnList = "ORGANIZE_CODE_EXT"),
        @Index(columnList = "CREATE_DATE_TIME_EXT"),
        @Index(columnList = "MODIFY_DATE_TIME_EXT")
})
@PrimaryKeyJoinColumn(name = "PID")
@Api("产品包装关系表拓展")
public class MesProdPackExt extends MesProdPack implements Serializable {

    private static final long serialVersionUID = 6873201906020279960L;

    @Column(name = "QUALITY_ASSURE_TEMPLATE")
    @ApiParam("质保书标签模板")
    private String qualityAssureTemplate;

    @Column(name = "PPT_CODE")
    @ApiParam("产品类型代码")
    private String pptCode;

    @Column(name = "BIG_PROCESS_LABEL_TEMPLATE")
    @ApiParam("大本体条码标签模板")
    private String bigProcessLabelTemplate;

    @Column(name = "BIG_PACKAGE_LABEL_TEMPLATE")
    @ApiParam("大包装条码标签模板")
    private String bigPackageLabelTemplate;

    @Column(name="ORGANIZE_CODE_EXT")
    @ApiParam(value ="组织代码")
    public String organizeCodeExt;

    @Column(name="IS_VALID_EXT")
    @ApiParam(value = "有效性")
    public Integer isValidExt;

    @Column(name="IS_DELETED_EXT")
    @ApiParam(value = "是否已删除")
    public Integer isDeletedExt;

    @Column(name="CREATE_USER_EXT")
    @ApiParam(value = "创建用户")
    public String createUserExt;

    @Column(name="CREATE_DATE_TIME_EXT")
    @ApiParam(value = "创建日期")
    public String createDatetimeExt;

    @Column(name="MODIFY_USER_EXT")
    @ApiParam(value = "修改人")
    public String modifyUserExt;

    @Column(name="MODIFY_DATE_TIME_EXT")
    @ApiParam(value = "修改日期")
    public String modifyDatetimeExt;
}
