package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Author: xiangming.liao
 * @CreateDate: 2021/02/03 9:35
 * @Description:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_PROJECT_CONFIRM")
@Api("工程巡回确认项目")
public class MesProjectConfirm extends BaseBean implements Serializable {
    private static final long serialVersionUID = 13549440186467018L;

    /**
     * 枚举选择：10=部品、20=工程、30=安全、40=设备、50=其他
     */
    @Column(name = "PROD_CFG_TYPE_CLASSIFY")
    @ApiParam("项目分类")
    private Integer prodCfgTypeClassify;

    @Column(name = "PROD_CFG_TYPE_CODE")
    @ApiParam("项目代码")
    private String prodCfgTypeCode;

    @Column(name = "PROD_CFG_TYPE_NAME")
    @ApiParam("项目名称")
    private String prodCfgTypeName;

}
