package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/4/7 15:47
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_REPLACEMENT_TRAVEL")
@Api("MES_换件履历表")
public class MesReplacementTravel extends BaseBean implements Serializable {

    private static final long serialVersionUID = 3111791568473952931L;

    @Column(name = "PART_NO")
    @ApiParam("父物料号")
    private String partNo;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("父物料名称")
    private String partName;

    @Column(name = "OLD_BAR_CODE")
    @ApiParam("旧部件条码")
    private String oldBarCode;

    @Column(name = "NEW_BAR_CODE")
    @ApiParam("新部件条码")
    private String newBarCode;

    @Column(name = "ITEM_PART_NO")
    @ApiParam("子物料号")
    private String itemPartNo;

    @Column(name = "ITEM_PART_NAME")
    @ApiParam("子物料名称")
    private String itemPartName;

    @Column(name = "SERIAL_NUMBER")
    @ApiParam("产品条码")
    private String serialNumber;

}
