package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Description :配置表
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-06-04
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_REWORK_SN", indexes = {
        @Index(columnList = "REWORK_ORDER_NO"),
        @Index(columnList = "PACKAGE_NO"),
        @Index(columnList = "WORK_CENTER_CODE"),
        @Index(columnList = "REWORK_ORDER_NO, PACKAGE_NO"),
})
@Api("返工条码表")
public class MesReworkSn extends BaseBean implements Serializable {

    private static final long serialVersionUID = -346986603249904700L;
    //@Column(name = "WORK_ORDER_NO")
    //@ApiParam("初始工单号")
    //private String workOrderNo;

    @Column(name = "REWORK_ORDER_NO")
    @ApiParam("返工工单号")
    private String reworkOrderNo;

    @Column(name = "PART_NO")
    @ApiParam("物料编码")
    private String partNo;

    @Column(name = "PART_NAME")
    @ApiParam("物料名称")
    private String partName;

    @Column(name = "PACKAGE_NO")
    @ApiParam("包装条码")
    private String packageNo;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("产线代码")
    private String workCenterCode;

    @Column(name = "ERP_WARE_HOUSE")
    @ApiParam("Erp库存地")
    private String erpWarehouse;

    @Column(name = "SYSTEM_SYNC_STATUS")
    @ApiParam("同步字段")
    private Integer systemSyncStatus;

}
