package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_SKILL_KANBAN_PROCESS_INFORMATION")
@Api("技能看板工序信息")
public class MesSkillKanbanProcessInformation extends BaseBean implements Serializable {
    private static final long serialVersionUID = -4978595260202493894L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam(value = "产线代码")
    private String workCenterCode;

    @Column(name = "SKILL_KANBAN_PROCESS_CODE")
    @ApiParam(value = "技能看板工序代码")
    private String skillKanbanProcessCode;

    @Column(name = "SKILL_KANBAN_PROCESS_NAME")
    @ApiParam(value = "技能看板工序名称")
    private String skillKanbanProcessName;

    @Column(name = "PROCESS_LABEL_CODE")
    @ApiParam(value = "工序标签标示代码")
    private String processLabelCode;

    @Column(name = "PROCESS_LABEL_NAME")
    @ApiParam(value = "工序标签标示名称")
    private String processLabelName;

}
