package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_SKILLS_MANAGEMENT_BENCHMARK")
@Api("技能管理基准")
public class MesSkillsManagementBenchmark extends BaseBean implements Serializable {
    private static final long serialVersionUID = 7926137039889848206L;

    @Column(name = "SKILL_LEVEL")
    @ApiParam(value = "技能水平(A对应图形红色圆圈、B对应图形黄色圆圈、C对应图形蓝色圆圈、D对应图形白色圆圈，且是唯一字段)")
    private String skillLevel;

    @Column(name = "STANDARD")
    @ApiParam(value = "基准")
    private String standard;

}
