package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/2/2 13:23
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_SPE_PARAM")
@Api("MES_设备参数")
public class MesSpeParam extends BaseBean implements Serializable {
    private static final long serialVersionUID = 4288859117496724259L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("工作中心代码")
    private String workCenterCode;

    @Column(name = "WORK_CELL_CODE")
    @ApiParam(value = "工位代码")
    public String workCellCode;

    @Column(name = "WORK_CELL_NAME")
    @ApiParam("工位名称")
    private String workCellName;

    @Column(name = "EQU_NO")
    @ApiParam("设备编号")
    private String equNo;

    @Column(name = "PARAM_NO")
    @ApiParam("参数编号")
    private String paramNo;

    @Column(name = "PARAM_DESC")
    @ApiParam("参数描述")
    private String paramDesc;

    @Column(name = "BEFORE_PARAM")
    @ApiParam("变化前参数")
    private String beforeParam;

    @Column(name = "AFTER_PARAM")
    @ApiParam("变化后参数")
    private String afterParam;

    @Column(name = "TEAM_CONFIRM_USER")
    @ApiParam("班组确认人")
    private String teamConfirmUser;

    @Column(name = "TEAM_CONFIRM_TIME")
    @ApiParam("班组确认时间")
    private String teamConfirmTime;

    @Column(name = "QUALITY_CONFIRM_USER")
    @ApiParam("品质确认人")
    private String qualityConfirmUser;

    @Column(name = "QUALITY_CONFIRM_TIME")
    @ApiParam("品质确认时间")
    private String qualityConfirmTime;

    @Column(name = "IS_TEAM_CONFIRM")
    @ApiParam("是否班组确认")
    private Integer isTeamConfirm = 20;

    @Column(name = "IS_QUALITY_CONFIRM")
    @ApiParam("是否品质确认")
    private Integer isQualityConfirm = 20;

    @Column(name = "PARAM_GROUP")
    @ApiParam("参数组")
    private String paramGroup;

    @Column(name = "PARAM_STATUS")
    @ApiParam("参数状态")
    private Integer paramStatus;

    @Column(name = "PARAM_VALUE")
    @ApiParam("参数值")
    private String paramValue;

    @Column(name = "EQU_NAME")
    @ApiParam("设备名称")
    private String equName;

    @Column(name = "SPE_PARAM_RESULT_ID")
    @ApiParam("关联结果id")
    private Long speParamResultId;

    @Transient
    @ApiParam("结果1")
    private String result1;

    @Transient
    @ApiParam("结果2")
    private String result2;

    @Transient
    @ApiParam("结果3")
    private String result3;

    @Transient
    @ApiParam("结果4")
    private String result4;

    @Transient
    @ApiParam("结果5")
    private String result5;

    @Transient
    @ApiParam("结果6")
    private String result6;

    @Transient
    @ApiParam("结果7")
    private String result7;

    @Transient
    @ApiParam("结果8")
    private String result8;

    @Transient
    @ApiParam("结果9")
    private String result9;

    @Transient
    @ApiParam("结果10")
    private String result10;


}
