package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_TEAM_MANAGEMENT_INTRODUCE_EXT", indexes = {
        @Index(columnList = "ORGANIZE_CODE_EXT"),
        @Index(columnList = "CREATE_DATE_TIME_EXT"),
        @Index(columnList = "MODIFY_DATE_TIME_EXT")
})
@PrimaryKeyJoinColumn(name = "PID")
@Api("团队管理介绍扩展表")
public class MesTeamManagementIntroduceExt extends MesTeamManagementIntroduce implements Serializable {
    private static final long serialVersionUID = 3385827404723078547L;

    @Column(name = "LOT_NO")
    @ApiParam("批次号")
    private String lotNo;

    @Column(name = "FILE_ID_GROUP")
    @ApiParam("文件id")
    private Long fileIdGroup;

    @Column(name = "URL_GROUP")
    @ApiParam("图片url")
    private String urlGroup;

    @Column(name = "FILE_ORIGIN_NAME_GROUP")
    @ApiParam("文件原名")
    private String fileOriginNameGroup;

    @Column(name = "UPLOAD_DATE_TIME_GROUP")
    @ApiParam("上传时间")
    private String uploadDatetimeGroup;

    @Column(name = "FILE_ID_SHIFT")
    @ApiParam("文件id")
    private Long fileIdShift;

    @Column(name = "URL_SHIFT")
    @ApiParam("图片url")
    private String urlShift;

    @Column(name = "FILE_ORIGIN_NAME_SHIFT")
    @ApiParam("文件原名")
    private String fileOriginNameShift;

    @Column(name = "UPLOAD_DATE_TIME_SHIFT")
    @ApiParam("上传时间")
    private String uploadDatetimeShift;

    @Column(name="ORGANIZE_CODE_EXT")
    @ApiParam(value ="组织代码")
    public String organizeCodeExt;

    @Column(name="IS_VALID_EXT")
    @ApiParam(value = "有效性")
    public Integer isValidExt;

    @Column(name="IS_DELETED_EXT")
    @ApiParam(value = "是否已删除")
    public Integer isDeletedExt;

    @Column(name="CREATE_USER_EXT")
    @ApiParam(value = "创建用户")
    public String createUserExt;

    @Column(name="CREATE_DATE_TIME_EXT")
    @ApiParam(value = "创建日期")
    public String createDatetimeExt;

    @Column(name="MODIFY_USER_EXT")
    @ApiParam(value = "修改人")
    public String modifyUserExt;

    @Column(name="MODIFY_DATE_TIME_EXT")
    @ApiParam(value = "修改日期")
    public String modifyDatetimeExt;

}
