package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Author: wangjie
 * @CreateDate: 2019/7/30 9:30 AM
 * @Description:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_WORK_CELL_PRINT_RECORD_DETAIL", indexes = {
        @Index(columnList = "WORK_ORDER_NO, TAG_TYPE"),
        @Index(columnList = "SN, TAG_TYPE"),
        @Index(columnList = "WORK_ORDER_NO, SN, TAG_TYPE")
})
@Api("工位人工打印记录明细")
public class MesWorkCellPrintRecordDetail extends BaseBean implements Serializable {

    private static final long serialVersionUID = 9155198607062003459L;

    @Column(name = "OBJECT_CODE")
    @ApiParam("对象代码")
    private String objectCode;

    @Column(name = "OBJECT_NAME")
    @ApiParam("对象名称")
    private String objectName;

    @Column(name = "SOURCE_MODULE")
    @ApiParam("来源模块")
    private String sourceModule;

    @Column(name = "PRINT_DATE_TIME")
    @ApiParam("打印时间")
    private String printDatetime;

    @Column(name = "TAG_TYPE")
    @ApiParam("标签类型")
    private Integer tagType;

    @Column(name = "PID")
    @ApiParam("ID")
    private Long pid;

    @Column(name = "SN")
    @ApiParam("条码")
    private String sn;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("生产工单号")
    private String workOrderNo;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("生产线")
    private String workCenterCode;

    @Column(name = "PART_NO")
    @ApiParam("物料编码")
    private String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam("物料名称")
    private String partNameRdd;

}
