package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Author: wangjie
 * @CreateDate: 2019/7/30 9:30 AM
 * @Description:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "MES_WORK_CENTER_CONTAINER_LOCATION_RECORD")
@Api("产线托盘位置记录表")
public class MesWorkCenterContainerLocationRecord extends BaseBean implements Serializable {

    private static final long serialVersionUID = 8119307620415349725L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("生产线代码")
    private String workCenterCode;

    @Column(name = "CT_LOCATION_NO")
    @ApiParam("容器位置编号")
    private String ctLocationNo;

    @Column(name = "LOCATION_DESC")
    @ApiParam("容器位置描述")
    private String locationDesc;

    @Column(name = "LOCATION_TYPE")
    @ApiParam("位置类型")
    private Integer locationType;

    @Column(name = "CT_NO")
    @ApiParam("容器编号")
    private String ctNo;

}
