package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/12 15:58
 **/
@EqualsAndHashCode(callSuper = true)
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "MES_WORK_ORDER_LOG_EXT", indexes = {
        @Index(columnList = "SYSTEM_SYNC_STATUS_EXT"),
        @Index(columnList = "ORGANIZE_CODE_EXT"),
        @Index(columnList = "CREATE_DATE_TIME_EXT"),
        @Index(columnList = "MODIFY_DATE_TIME_EXT")
})
@PrimaryKeyJoinColumn(name = "PID", foreignKey = @ForeignKey(ConstraintMode.NO_CONSTRAINT))
@Api("生产工单日志表拓展")
public class MesWorkOrderLogExt extends MesWorkOrderLog implements Serializable {

    private static final long serialVersionUID = 8178872323483951014L;

    @Column(
            name = "PLAN_QTY",
            columnDefinition = "decimal(18,8)"
    )
    @ColumnDefault("0")
    @ApiParam("计划返工数量")
    private Double planQty;

    @Column(
            name = "PLAN_COMPLETE_QTY",
            columnDefinition = "decimal(18,8)"
    )
    @ColumnDefault("0")
    @ApiParam("计划完成数量")
    private Double planCompleteQty;

    @Column(name = "SN_CREATE_STATUS")
    @ApiParam("条码生成状态")
    private Integer snCreateStatus;

    @Column(
            name = "MISSING_QTY",
            columnDefinition = "decimal(18,8)"
    )
    @ColumnDefault("0")
    @ApiParam("缺件数量")
    private Double missingQty;

    @Column(name = "ERP_WARE_HOUSE")
    @ApiParam("Erp库存地")
    private String erpWarehouse;

    @Column(name="ORGANIZE_CODE_EXT")
    @ApiParam(value ="组织代码")
    public String organizeCodeExt;

    @Column(name="IS_VALID_EXT")
    @ApiParam(value = "有效性")
    public Integer isValidExt;

    @Column(name="IS_DELETED_EXT")
    @ApiParam(value = "是否已删除")
    public Integer isDeletedExt;

    @Column(name="CREATE_USER_EXT")
    @ApiParam(value = "创建用户")
    public String createUserExt;

    @Column(name="CREATE_DATE_TIME_EXT")
    @ApiParam(value = "创建日期")
    public String createDatetimeExt;

    @Column(name="MODIFY_USER_EXT")
    @ApiParam(value = "修改人")
    public String modifyUserExt;

    @Column(name="MODIFY_DATE_TIME_EXT")
    @ApiParam(value = "修改日期")
    public String modifyDatetimeExt;

    @Column(name = "SYSTEM_SYNC_STATUS_EXT")
    @ColumnDefault("2")
    @ApiParam(value = "系统同步标志")
    public Integer systemSyncStatusExt = 2;

}
