package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "SX_OQC_BATCH")
@NoArgsConstructor
@AllArgsConstructor
@Api("出货检验批次同步表")
public class SxOqcBatch extends BaseBean implements Serializable {

    private static final long serialVersionUID = -6569952078532757407L;

    @Column(name = "WORK_TIME")
    @ApiParam("批次代码")
    private String workTime;

    @Column(name = "SHIFT_CODE")
    @ApiParam("班次代码")
    private String shiftCode;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("生产工单号")
    private String workOrderNo;

    @Column(name = "CHECK_RESULT")
    @ApiParam("检验结果 10:合格,20:不合格")
    private Integer checkResult;

    @Column(name = "SYNC_STATUS")
    @ApiParam("同步状态 1:wms处理完成,2:默认")
    private Integer syncStatus;

}
