package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @author yumingxing
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "SX_OQC_CHECK")
@NoArgsConstructor
@AllArgsConstructor
@Api("出货检验检验单同步表")
public class SxOqcCheck extends BaseBean implements Serializable {

    private static final long serialVersionUID = -5930788722884086319L;

    @Column(name = "OQC_NO")
    @ApiParam("检验单号")
    private String oqcNo;

    @Column(name = "OQC_TYPE")
    @ApiParam("检验类型")
    private Integer oqcType;

    @Column(name = "PART_NO")
    @ApiParam("物料编码")
    private String partNo;

    @Column(name = "PART_NAME")
    @ApiParam("物料名称")
    private String partName;

    @Column(name = "WORK_TIME")
    @ApiParam("批次代码")
    private String workTime;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("生产线")
    private String workCenterCode;

    @Column(name = "SHIFT_CODE")
    @ApiParam("班次代码")
    private String shiftCode;

    @Column(name = "CATEGORY_CODE3")
    @ApiParam("产品类别")
    private String categoryCode3;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("生产工单号")
    private String workOrderNo;

    @Column(name = "CHECK_RESULT")
    @ApiParam("检验结果 10:合格,20:不合格")
    private Integer checkResult;

    @Column(name = "SYNC_STATUS")
    @ApiParam("同步状态 1:wms处理完成,2:默认")
    private Integer syncStatus;

}
