package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @author yumingxing
 */
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "SX_OQC_SINGLE")
@NoArgsConstructor
@AllArgsConstructor
@Api("出货检验同步表")
public class SxOqcSingle extends BaseBean implements Serializable {

    private static final long serialVersionUID = 1548766610061433180L;

    @Column(name = "OQC_NO")
    @ApiParam("出货检验单号")
    private String oqcNo;

    @Column(name = "WORK_ORDER_NO")
    @ApiParam("生产工单号")
    private String workOrderNo;

    @Column(name = "PRODUCT_SN")
    @ApiParam("产品条码")
    private String productSn;

    @Column(name = "SERIAL_NUMBER")
    @ApiParam("过程条码")
    private String serialNumber;

    @Column(name = "PACKAGE_NO")
    @ApiParam("包装条码")
    private String packageNo;

    @Column(name = "PART_NO")
    @ApiParam("物料号")
    private String partNo;

    @Column(name = "CHECK_RESULT")
    @ApiParam("检验结果 10:合格,20:不合格")
    private Integer checkResult;

    @Column(name = "SYNC_STATUS")
    @ApiParam("同步状态 1:wms处理完成,2:默认")
    private Integer syncStatus;

}
