package cn.estsh.i3plus.ext.mes.pcn.pojo.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;

/**
 * @Description:
 * @Reference:
 * @Author: wangjie
 * @CreateDate: 2019\11\15 10:12
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Inheritance(strategy = InheritanceType.JOINED)
@Table(name = "SX_PRODUCT_OFF_LINE_MOVTRN", indexes = {
        @Index(columnList = "FLAG")
})
@NoArgsConstructor
@AllArgsConstructor
@Api("生产报工立库关联表")
public class SxProductOffLineMovtrn extends BaseBean implements Serializable {

    private static final long serialVersionUID = 792171740171786366L;

    @Column(name = "WORK_CENTER_CODE")
    @ApiParam("产线")
    private String workCenterCode;

    @Column(name = "PART_NO")
    @ApiParam("物料号")
    private String partNo;

    @Column(name = "PART_NAME_RDD")
    @ApiParam("物料名称")
    private String partNameRdd;

    @Column(name = "PACKAGE_NO")
    @ApiParam("容器条码")
    private String packageNo;

    @Column(name = "SERIAL_NUMBER")
    @ApiParam("包装条码")
    private String serialNumber;

    @Column(name = "SERIAL_NUMBER_QTY")
    @ApiParam("包装条码数量")
    private Integer serialNumberQty;

    @Column(name = "STATUS")
    @ApiParam("是否入库")
    private Integer status;

    @Column(name = "LOT_NO")
    @ApiParam("生产批次")
    private String lotNo;

    @Column(name = "FLAG")
    @ApiParam("同步状态")
    private Integer flag;

}
