package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@ApiModel("SOP")
public class EsopExtModel implements Serializable {

    private static final long serialVersionUID = 8959223878801706187L;

    @ApiParam("id")
    private Long id;

    @ApiParam("生产工单号")
    private String workOrderNo;

    @ApiParam("零件号")
    private String partNo;

    @ApiParam("工作中心代码")
    private String workCenterCode;

    @ApiParam("工作单元代码")
    private String workCellCode;

    @ApiParam("工序代码")
    private String processCode;

    @ApiParam("文件ID")
    private Long fileId;

    @ApiParam("文件名称")
    private String fileName;

    @ApiParam("文件URL")
    private String fileUrl;

    @ApiParam("组名")
    private String groupName;

    @ApiParam("文件原名")
    private String fileOriginName;

    @ApiParam("文件大小")
    private String fileSize;

    @ApiParam("文件类型名称")
    private String fileType;

    @ApiParam("播放顺序")
    private Double bcSeq;

    @ApiParam("播放时长")
    private Double bcTimes;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("有效性")
    public Integer isValid;

    @ApiParam("是否已删除")
    public Integer isDeleted;

    @ApiParam("创建用户")
    public String createUser;

    @ApiParam("创建日期")
    public String createDatetime;

    @ApiParam("修改人")
    public String modifyUser;

    @ApiParam("修改日期")
    public String modifyDatetime;

    @ApiParam("上传时间")
    private String uploadDatetime;

    public EsopExtModel() {
    }

    public EsopExtModel(Long id, String workOrderNo, String partNo, String workCenterCode, String workCellCode, String processCode, Long fileId, String fileName,
                        String fileUrl, String groupName, String fileOriginName, String fileSize, String fileType, Double bcSeq, Double bcTimes, String uploadDatetime,
                        String organizeCode, Integer isValid, Integer isDeleted, String createUser, String createDatetime, String modifyUser, String modifyDatetime) {
        this.id = id;
        this.workOrderNo = workOrderNo;
        this.partNo = partNo;
        this.workCenterCode = workCenterCode;
        this.workCellCode = workCellCode;
        this.processCode = processCode;
        this.fileId = fileId;
        this.fileName = fileName;
        this.fileUrl = fileUrl;
        this.groupName = groupName;
        this.fileOriginName = fileOriginName;
        this.fileSize = fileSize;
        this.fileType = fileType;
        this.bcSeq = bcSeq;
        this.bcTimes = bcTimes;
        this.uploadDatetime = uploadDatetime;
        this.organizeCode = organizeCode;
        this.isValid = isValid;
        this.isDeleted = isDeleted;
        this.createUser = createUser;
        this.createDatetime = createDatetime;
        this.modifyUser = modifyUser;
        this.modifyDatetime = modifyDatetime;
    }
}
