package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import cn.estsh.i3plus.pojo.base.annotation.AnnoOutputColumn;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/1/14 10:15
 **/
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("生产工单导入模板")
public class ExcelWorkOrderDto {

    @ApiParam("订单")
    @AnnoOutputColumn
    private String orderNo;

    @ApiParam("物料描述")
    @AnnoOutputColumn
    private String partNameRdd;

    @ApiParam("物料编号")
    @AnnoOutputColumn
    private String partNo;

    @ApiParam("订单数量 (GMEIN)")
    @AnnoOutputColumn
    private Double qty;

    @ApiParam("已交货数量 (GMEIN)")
    @AnnoOutputColumn
    private Double completeQty;

    @ApiParam("基本开始日期")
    @AnnoOutputColumn
    private String startTime;

    @ApiParam("基本完成日期")
    @AnnoOutputColumn
    private String endTime;

    @ApiParam("订单类型")
    @AnnoOutputColumn
    private Integer workOrderType;

    @ApiParam("MRP控制")
    @AnnoOutputColumn
    private String mrpControl;

    @ApiParam("工厂")
    @AnnoOutputColumn
    private String factory;

    @ApiParam("生产线")
    @AnnoOutputColumn
    private String workCenterCode;

    @ApiParam("输入者")
    @AnnoOutputColumn
    public String importer;

    @ApiParam("Erp库存地")
    @AnnoOutputColumn
    private String erpWarehouse;

}
