package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @author xiangming.liao
 * @version 1.0
 * @date 2021/03/12
 **/
@Data
@ApiModel("外观防划伤明细model")
public class MesExteriorScratchProofDetailModel implements Serializable {

    private static final long serialVersionUID = -6037379883042449241L;

    @ApiParam("id")
    private Long id;

    @ApiParam("生产线代码")
    private String workCenterCode;

    @ApiParam(value = "工位代码")
    public String workCellCode;

    @ApiParam(value = "单据时间")
    private String orderTime;

    @ApiParam(value ="单据编号")
    private String orderNo;

    /**
     * OK显示O，NG显示X
     */
    @ApiParam("点检结果")
    private Integer checkResult;

    @ApiParam("点检人员")
    private String checkUser;

    @ApiParam("点检时间")
    private String checkTime;

    /**
     * 10=是，20=否
     */
    @ApiParam("班组确认")
    private Integer shiftGroupCheck = 20;

    @ApiParam("班组确认人")
    private String shiftGroupCheckUser;

    @ApiParam("班组确认时间")
    private String shiftGroupCheckTime;

    /**
     * 10=是，20=否
     */
    @ApiParam("品质确认")
    private Integer qualityCheck= 20;

    @ApiParam("品质确认人")
    private String qualityCheckUser;

    @ApiParam("品质确认时间")
    private String qualityCheckTime;

    @ApiParam("文件ID")
    private Long fileId;

    @ApiParam("文件名称")
    private String fileName;

    @ApiParam("文件URL")
    private String fileUrl;

    @ApiParam("组名")
    private String groupName;

    @ApiParam("文件原名")
    private String fileOriginName;

    @ApiParam("文件大小")
    private String fileSize;

    @ApiParam("文件类型名称")
    private String fileType;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("有效性")
    public Integer isValid;

    @ApiParam("是否已删除")
    public Integer isDeleted;

    @ApiParam("创建用户")
    public String createUser;

    @ApiParam("创建日期")
    public String createDatetime;

    @ApiParam("修改人")
    public String modifyUser;

    @ApiParam("修改日期")
    public String modifyDatetime;

    @ApiParam("备注")
    public String remark;

    public MesExteriorScratchProofDetailModel() {
    }

    public MesExteriorScratchProofDetailModel(Long id, String workCenterCode, String workCellCode, String orderTime, String orderNo, Integer checkResult, String checkUser, String checkTime, Integer shiftGroupCheck, String shiftGroupCheckUser, String shiftGroupCheckTime, Integer qualityCheck, String qualityCheckUser, String qualityCheckTime, Long fileId, String fileName, String fileUrl, String groupName, String fileOriginName, String fileSize, String fileType, String organizeCode, Integer isValid, Integer isDeleted, String createUser, String createDatetime, String modifyUser, String modifyDatetime, String remark) {
        this.id = id;
        this.workCenterCode = workCenterCode;
        this.workCellCode = workCellCode;
        this.orderTime = orderTime;
        this.orderNo = orderNo;
        this.checkResult = checkResult;
        this.checkUser = checkUser;
        this.checkTime = checkTime;
        this.shiftGroupCheck = shiftGroupCheck;
        this.shiftGroupCheckUser = shiftGroupCheckUser;
        this.shiftGroupCheckTime = shiftGroupCheckTime;
        this.qualityCheck = qualityCheck;
        this.qualityCheckUser = qualityCheckUser;
        this.qualityCheckTime = qualityCheckTime;
        this.fileId = fileId;
        this.fileName = fileName;
        this.fileUrl = fileUrl;
        this.groupName = groupName;
        this.fileOriginName = fileOriginName;
        this.fileSize = fileSize;
        this.fileType = fileType;
        this.organizeCode = organizeCode;
        this.isValid = isValid;
        this.isDeleted = isDeleted;
        this.createUser = createUser;
        this.createDatetime = createDatetime;
        this.modifyUser = modifyUser;
        this.modifyDatetime = modifyDatetime;
        this.remark = remark;
    }
}
