package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/3/19 10:25
 **/
@Data
@NoArgsConstructor
@AllArgsConstructor
@Api("出货检验")
public class OqcCheck {

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("条码")
    private String serialNumber;

    @ApiParam("工单号")
    private String orderNo;

    @ApiParam("物料编码")
    private String partNo;

    @ApiParam("物料名称")
    private String partName;

    @ApiParam("生产日期")
    private String workTime;

    @ApiParam("生产线")
    private String workCenterCode;

    @ApiParam("班次")
    private String shiftCode;

    @ApiParam("计划数量")
    private Double planQty;

    @ApiParam("班次完工数量")
    private Double completeQty;

    @ApiParam("已检测范围数量")
    private Double checkLimit;

    @ApiParam("检验单号")
    private String oqcNo;

    @ApiParam("抽检数量")
    private Double spotCheckQty;

    @ApiParam("批次范围")
    private Double batchLimit;

    @ApiParam("检验类型")
    private Integer oqcType;

    @ApiParam("批次范围是否可以修改")
    private boolean isUpdateBtn;

    @ApiParam("生成按钮")
    private boolean isInsertBtn;

    @ApiParam("合格按钮")
    private boolean isQualifiedBtn;

    @ApiParam("不合格按钮")
    private boolean isUnQualifiedBtn;

    @ApiParam("成功提示信息")
    private String successMsg;

    @ApiParam("所属类型")
    private String attrType;


}
