package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesBadCellDetail;
import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesRepairRecordExt;
import cn.estsh.i3plus.pojo.mes.bean.*;
import cn.estsh.i3plus.pojo.mes.model.ActionRequestModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/4/6 15:56
 **/

@Data
@NoArgsConstructor
@AllArgsConstructor
public class RepairRequestModel {


    private List<MesBadCellDetail> mesDefectRecordList; // 不良/缺陷记录数据集

    private List<MesRepairRecordExt> mesRepairRecordList; // 维修记录数据集

    private List<MesDismantleRecord> dismantleRecordList; // 拆解记录数据集

    private List<MesWorkOrder> workOrderList; // 工单数据集

    private List<MesPart> partList; // 物料数据集

    private List<MesPlanOrder> planOrderList; // 生产计划数据集

    private List<MesQueueOrder> queueOrderList; // 生产队列数据集

    private Double currentSeq; // 生产队列中的当前序列号

    private Double nextSeq; // 生产队列中的下一个序列号

    private Integer srcStatus; // 源状态

    private Integer destStatus; // 目的状态

    private List<String> orderNoList;//工单编号

    private List<ActionRequestModel> requestBeanList;//工单下达

    private ActionRequestModel actionRequestBean;//工单状态

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("生产线代码")
    public String workCenterCode;

    @ApiParam("工位代码")
    public String workCellCode;

    @ApiParam("工序代码")
    public String processCode;

    @ApiParam("有效性")
    public Integer isValid;

    @ApiParam("是否已删除")
    public Integer isDeleted;

    @ApiParam("创建用户")
    public String createUser;

    @ApiParam("创建日期")
    public String createDatetime;

    @ApiParam("修改人")
    public String modifyUser;

    @ApiParam("修改日期")
    public String modifyDatetime;

    @ApiParam("过程条码")
    private String serialNumber;

}