package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesPartExt;
import cn.estsh.i3plus.pojo.mes.bean.MesLabelTemplate;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@ApiModel("打印模板MODEL")
public class SxPrintTemplateModel implements Serializable {

    private static final long serialVersionUID = 2665980491054296200L;

    @ApiParam("打印模板对象集合(存在不同打印模板时使用此属性)")
    private List<SxPrintTemplateModel> printTemplateList;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("打印模板")
    private MesLabelTemplate labelTemplate;

    @ApiParam("物料信息")
    private MesPartExt part;

    @ApiParam("产品条码信息")
    private ProduceSnExtModel sn;

    @ApiParam("包装条码信息")
    private PackageExtModel pack;

    @ApiParam("大包装条码信息")
    private BigOuterPackageModel bigOuterPackageModel;

    @ApiParam("产品条码信息")
    private List<ProduceSnExtModel> snList;

    @ApiParam("大包装条码信息")
    private List<BigOuterPackageModel> bigOuterPackageList;

    @ApiParam("包装条码信息")
    private List<PackageExtModel> packList;

    @ApiParam("操作人")
    private String userInfo;

    @ApiParam("批量打印的条码Id集合")
    private List<Long> idList;

    @ApiParam("工单编号")
    private String workOrderNo;

    @ApiParam("单个排序字段")
    private String orderByParam;

    @ApiParam("单个排序类型，1 正序，2 倒序")
    private Integer ascOrDesc;

    @ApiParam("打印方式")
    private Integer printMode;

    @ApiParam("打印机代码")
    private String printerCode;

}
