package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.hibernate.annotations.ColumnDefault;

import javax.persistence.Column;
import java.io.Serializable;

/**
 * 文件描述
 *
 * @author xiangming.liao
 * @date 2021年03月29日 13:53
 */
@Data
@ApiModel("wmsBomTotalModel信息")
public class WmsBomTotalModel implements Serializable {
    private static final long serialVersionUID = -2495260378045608718L;

    @ApiParam("id")
    private Long id;

    @ApiParam("父物料号")
    private String partNo;

    @ApiParam("父物料描述")
    private String partName;

    @ApiParam("计量单位")
    private String UNIT;

    @ApiParam("数量")
    @ColumnDefault("0")
    private Double qty;

    @ApiParam("子物料号")
    private String itemPartNo;

    @ApiParam("子料物料描述")
    private String itemPartName;

    @ApiParam("子计量单位")
    private String itemUnit;

    @ApiParam("子用量")
    @ColumnDefault("0")
    private Double itemQty;

    @ApiParam("BOM编号")
    private String bomNum;

    @ApiParam("BOM版本号")
    private String bomVersion;

    @ApiParam("有效起始日期")
    private String effStartTime;

    @ApiParam("有效截止日期")
    private String effEndTime;

    @ApiParam("SID")
    private String sid;
    @ApiParam("是否虚阶物料")
    private String category;

    @ApiParam("组织代码")
    public String organizeCode;

    @ApiParam("有效性")
    public Integer isValid;

    @ApiParam("是否已删除")
    public Integer isDeleted;

    @ApiParam("创建用户")
    public String createUser;

    @ApiParam("创建日期")
    public String createDatetime;

    @ApiParam("修改人")
    public String modifyUser;

    @ApiParam("修改日期")
    public String modifyDatetime;
}
