package cn.estsh.i3plus.ext.mes.pcn.pojo.model;

import cn.estsh.i3plus.pojo.mes.model.MesButtonFlagModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * @author yumingxing
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("生成工单分页显示页面")
public class WorkOrderPageVo implements Serializable {

    @ApiParam("工单状态代码")
    private Integer workOrderStatus;

    @ApiParam("工单状态")
    private String workOrderStatusName;

    @ApiParam("工单号")
    private String orderNo;

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("物料名称")
    private String partNameRdd;

    @ApiParam("区域代码")
    private String areaCode;

    @ApiParam("生产线代码")
    private String workCenterCode;

    @ApiParam("生产线名称")
    public String workCenterName;

    @ApiParam("计划数量")
    private Double qty;

    @ApiParam("返工计划数量")
    private Double planQty;

    @ApiParam("完成数量")
    private Double completeQty;

    @ApiParam("返修数量")
    private Double repairQty;

    @ApiParam("报废数量")
    private Double scarpQty;

    @ApiParam("工单类型代码-正常/试制/返工")
    private Integer workOrderType;

    @ApiParam("工单类型")
    private String workOrderTypeName;

    @ApiParam("计划开始时间")
    private String startTime;

    @ApiParam("计划结束时间")
    private String endTime;

    @ApiParam("实际开始时间")
    private String realStartTime;

    @ApiParam("实际结束时间")
    private String realEndTime;

    @ApiParam("备注")
    private String memo;

    @ApiParam("工单来源")
    private String workOrderSource;

    @ApiParam("创建人")
    private String createUser;

    @ApiParam("创建时间")
    private String createDatetime;

    @ApiParam("编辑人")
    private String modifyUser;

    @ApiParam("编辑时间")
    private String modifyDatetime;

    @ApiParam("排产日期")
    private String scheduleDate;

    @ApiParam("按钮")
    private MesButtonFlagModel mesButtonFlagModel;

    @ApiParam
    private Long id;

    @ApiParam("缺件数量")
    private Double missingQty;

    @ApiParam("生产排序")
    private Double seq;

    @ApiParam("生产排序")
    private Double seq1;


}
