package cn.estsh.i3plus.ext.mes.pcn.pojo.model.bu;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

/**
 * @author wangjie
 * @version 1.0
 * @date 2021/1/15 15:32
 **/
@Data
@ApiModel("出货检验MODEL")
public class SxBuOqcDataModel implements Serializable {

    private static final long serialVersionUID = 7332024681023976698L;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("产品条码")
    private String serialNumber;

    @ApiParam("包装条码")
    private String packageNo;

    @ApiParam("生产工单")
    private String workOrderNo;

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("物料名称")
    private String partNameRdd;

    @ApiParam("生产线")
    private String workCenterCode;

    @ApiParam("工单类型")
    private Integer workOrderType;

    @ApiParam("工单类型名称")
    private String workOrderTypeName;

    @ApiParam("作业时间")
    private String workTime;

    @ApiParam("班次代码")
    private String shiftCode;

    @ApiParam("班次名称")
    private String shiftName;

    @ApiParam("计划数量")
    private Double planQty;

    @ApiParam("班次完工数量")
    private Double completeQty;

    @ApiParam("产量统计ID")
    private String idStr;

    @ApiParam("下线产品集合")
    private List<Map<String, String>> prodMapList;

    //@ApiParam("是否必须携带大包装条码标志")
    //private Boolean isNeedBigPackFlag;

    public SxBuOqcDataModel() {}

    public SxBuOqcDataModel(String organizeCode, String serialNumber) {
        this.organizeCode = organizeCode;
        this.serialNumber = serialNumber;
    }

    public SxBuOqcDataModel(String organizeCode) {
        this.organizeCode = organizeCode;
    }
}
