package cn.estsh.i3plus.ext.mes.pcn.pojo.model.ep;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-dev
 * @DESCRIPTION:
 * @USER: xinwang.yi
 * @DATE: 2021-12-20 13:01
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel("本体/组件返修作业-不良明细MODEL")
public class EpBadCellDetailModel implements Serializable {

    private static final long serialVersionUID = -912712875623356571L;

    @ApiParam(value = "产线代码")
    private String workCenterCode;

    @ApiParam("班次代码")
    private String shiftCode;

    @ApiParam("作业时间")
    private String workTime;

    @ApiParam(value = "生产工单号")
    public String workOrderNo;

    @ApiParam(value = "工位代码")
    public String workCellCode;

    @ApiParam(value = "物料号")
    private String partNo;

    @ApiParam("物料名称")
    private String partNameRdd;

    @ApiParam("不良时间")
    private String defectActionTime;

    @ApiParam("不良类型代码")
    private String defectType;

    @ApiParam("不良类型描述")
    private String defectTypeName;

    @ApiParam("不良标识代码")
    private String defectCode;

    @ApiParam("不良标识描述")
    private String defectName;

    //MesPcnEnumUtil.MES_REPAIR_STATUS
    @ApiParam("维修状态")
    private Integer repairStatus = 20;

    @ApiParam("过程条码")
    private String serialNumber;

    //---EP---
    @ApiParam("原材料物料编码")
    private String itemPartNo;

    @ApiParam("原材料物料名称")
    private String itemPartName;

    @ApiParam("发生岗位")
    private String happenStation;
    //---EP---

    @ApiParam("缺陷")
    private List<EpDefectModel> mesDefectList;

    private String orderNo;

    @ApiParam("id")
    private Long id;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("创建用户")
    private String createUser;

    @ApiParam("创建日期")
    private String createDatetime;

    @ApiParam("修改人")
    private String modifyUser;

    @ApiParam("修改日期")
    private String modifyDatetime;

}
