package cn.estsh.i3plus.ext.mes.pcn.pojo.model.ep;

import cn.estsh.i3plus.pojo.mes.bean.MesDefect;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.List;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-dev
 * @DESCRIPTION:
 * @USER: xinwang.yi
 * @DATE: 2021-12-20 13:27
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("缺陷MODEL")
public class EpDefectModel implements Serializable {

    private static final long serialVersionUID = 839861072126496126L;

    @ApiParam("缺陷代码")
    private String defectCode;

    @ApiParam("缺陷名称")
    private String defectName;

    @ApiParam("缺陷类型")
    private String defectType;

    @ApiParam("项目代码")
    private String prodCfgTypeCode;

    @ApiParam("不良处理类型")
    private String defectActionType;

    @ApiParam("缺陷标识值")
    private String defectFlagValue;

    @ApiParam("缺陷类型名称")
    private String defectTypeName;

    @ApiParam("缺陷位置")
    private String defectLocation;

    @ApiParam("颜色值")
    private String colorValue;

    @ApiParam("缺陷类型子集")
    private List<MesDefect> mesDefectList;

    @ApiParam("id")
    private Long id;

    @ApiParam("组织代码")
    private String organizeCode;

    @ApiParam("创建用户")
    private String createUser;

    @ApiParam("创建日期")
    private String createDatetime;

    @ApiParam("修改人")
    private String modifyUser;

    @ApiParam("修改日期")
    private String modifyDatetime;

    @ApiParam("原材料物料编码")
    private String itemPartNo;

    @ApiParam("原材料物料名称")
    private String itemPartName;

    @ApiParam("发生岗位")
    private String happenStation;

}
