package cn.estsh.i3plus.ext.mes.pcn.pojo.model.ep;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-dev
 * @DESCRIPTION:
 * @USER: xinwang.yi
 * @DATE: 2021-12-14 10:30
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("设备点检明细MODEL")
public class EpEquipmentCheckDetailModel implements Serializable {

    private static final long serialVersionUID = 1267474496869164123L;

    @ApiParam("id")
    private Long id;

    @ApiParam("单据编号")
    private String orderJobNo;

    @ApiParam("工作中心代码")
    private String workCenterCode;

    @ApiParam(value = "工位代码")
    public String workCellCode;

    @ApiParam("工位名称")
    private String workCellName;

    @ApiParam("设备编号")
    private String equNo;

    @ApiParam("设备名称")
    private String equName;

    @ApiParam("项目内容")
    private String projectContent;

    @ApiParam("点检方法")
    private String checkMethod;

    @ApiParam("点检周期")
    private String checkType;

    @ApiParam("点检结果")
    private Integer checkResult;

    @ApiParam("点检人员")
    private String spotCheckUser;

    @ApiParam("点检时间")
    private String spotCheckTime;

    @ApiParam("班组确认人")
    private String teamConfirmUser;

    @ApiParam("班组确认时间")
    private String teamConfirmTime;

    @ApiParam("品质确认人")
    private String qualityConfirmUser;

    @ApiParam("品质确认时间")
    private String qualityConfirmTime;

    @ApiParam("是否班组确认")
    private Integer isTeamConfirm = 20;

    @ApiParam("是否品质确认")
    private Integer isQualityConfirm = 20;

    @ApiParam(value = "班次编号")
    public String shiftCode;

    @ApiParam(value = "备注")
    public String remark;

    @ApiParam("结果类型")
    private Integer resultType;

    @ApiParam("标准值")
    private String standardValue;

    @ApiParam("上限值")
    private String upLimit;

    @ApiParam("下限值")
    private String downLimit;

    @ApiParam("实际值")
    private String resultValue;

    @ApiParam(value = "班组确认名称")
    public String shiftGroupCheckName;

    @ApiParam(value = "品质确认名称")
    public String qualityCheckName;

    @ApiParam("点检类型名称")
    private String checkTypeName;

    @ApiParam("点检结果名称")
    private String checkResultName;

    @ApiParam("结果类型名称")
    private String resutlTypeName;

    @ApiParam("有效性")
    public Integer isValid;


}
