package cn.estsh.i3plus.ext.mes.pcn.pojo.model.ep;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import java.io.Serializable;

/**
 * @PROJECT_NAME: i3plus-mes-panasonic-dev
 * @DESCRIPTION:
 * @USER: xinwang.yi
 * @DATE: 2021-12-21 15:59
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel("24小时泄露检测记录MODEL")
public class EpPartDivulgeCheckRecordModel implements Serializable {

    private static final long serialVersionUID = -8052124911942905182L;

    @ApiParam("物料编码")
    private String partNo;

    @ApiParam("物料编码名称")
    private String partName;

    @ApiParam("包装条码")
    private String packageNo;

    @ApiParam("产品条码")
    private String serialNumber;

    @ApiParam("生产工单号")
    private String workOrderNo;

    @ApiParam("检测结果")
    private Integer checkResult;

    @ApiParam("检测结果名称")
    private String checkResultName;

    @ApiParam("泄露值")
    private Double divulgeValue = 0.0;

    @ApiParam("下线时间")
    private String outWorkCenterTime;

    @ApiParam("检测时间")
    private String checkTime;

    @Column(name = "WORK_TIME")
    @ApiParam("作业时间")
    private String workTime;

    @ApiParam("班次")
    private String shiftCode;

    @ApiParam("批次号")
    private String lotNo;

}
